var g_socketLEid = -1;
var g_bluetoothLEPlugin = null;

var deviceVersion = "0";

window.addEventListener('load', function () {
    
	document.addEventListener('deviceready', function () {
        $('#debug').html("Platform LE is now ready!");
		deviceVersion = device.version;
		if(deviceVersion.indexOf("-") > 0) {
			deviceVersion = deviceVersion.substring(0, deviceVersion.indexOf("-"));
		}
		// alert("Device version: "+deviceVersion);
		g_bluetoothLEPlugin = cordova.require( 'cordova/plugin/bluetoothle' );
		if(window.localStorage.getItem("btle-device-text") != null && window.localStorage.getItem("btle-device-text") != "" && window.localStorage.getItem("btle-device-val") != null) {
			$('#btle-devices-select').append( $( '<option value="' + window.localStorage.getItem("btle-device-val") + '">' + window.localStorage.getItem("btle-device-text") + '</option>' ) );
			// setTimeout(loadOldConnectionLE, 2000);
		} else {
			// $('#btle-devices-select').append( $( '<option value="0C:8C:DC:00:11:69">Movesense HRS</option>' ) );
		}
    }, false);
}, false);

function loadOldConnectionLE() {
	
	g_bluetoothLEPlugin.enable( function() {
		$('#debug').html( 'Enabling successfull' );
	}, function(error) {
		$('#debug').html( 'Error loadOldConnection: ' + error );
	} );
}

function enableBTLE() {
	$('#debug').html( "enableBT" );
	g_bluetoothLEPlugin.enable( function() {
		$('#debug').html( 'Enabling successfull' );
		// discoverDevicesLE();
	}, function(error) {
		$('#debug').html( 'Error enabling BT: ' + error );
	} );
}

function disableBTLE() {
	$('#debug').html( "disableBT" );
	g_bluetoothLEPlugin.disable( function() {
		$('#debug').html( 'Disabling successfull' );
	}, function(error) {
		$('#debug').html( 'Error disabling BT: ' + error );
	} );
}

function discoverDevicesLE() {
	if(deviceVersion < "4.3") {
		alert("Heart Rate is not available in your device.");
	} else {
		// $('#debug').html("Please wait, discovering devices and it may takes over 10 seconds...");
		showDialog("Please wait", "Discovering Bluetooth devices. Please wait...", 0);
		// $('#btle-devices-select').html('');
		g_bluetoothLEPlugin.discoverDevices( function(devices) {
			$('#btle-devices-select').html('');
			
			var arr = new Array();
			var j = 0;
			for( var i = 0; i < devices.length; i++ ) {
				// $('#bt-devices-select').append( $( '<option value="' + devices[i].address + '">' + devices[i].name + '</option>' ) );
				arr[j++] = devices[i].address + ';' + devices[i].name;
				useHR = true;
				document.getElementById("use-hr").className = "useYellow";
				window.localStorage.setItem("myontec-use-hr", "1");
				if(devices[i].name.indexOf("MbM") == 0) {
				}
			}
			
			showBluetoothLEDialog(arr);
		}, function(error) { 
			$('#debug').html( 'Error discovering BT: ' + error );
			closeDialog();
			// showDialog("Please wait", 'Error: ' + error, 3000);
		});
	}
}

function discoverDevicesLEAndConnect() {
    $('#debug').html("Please wait, discovering devices and it may takes over 2 seconds...");
	g_bluetoothLEPlugin.discoverDevices( function(devices) {
		connectBLE();
    }, function(error) { 
		$('#debug').html( 'Error discovering BT: ' + error );
		closeDialog();
		// showDialog("Please wait", 'Error: ' + error, 3000);
	});
}

function pingBLE() {
	$('#debug').html( "Pinging..." );
	g_bluetoothLEPlugin.ping( function(p_data) {
		$('#debug').html( 'debug: ' + p_data );
	}, function(error) {
		$('#debug').html( 'Error ping: ' + error );
	});
}

function connectBLE() {
	$('#debug').html( "Connecting BLE..." );
	g_bluetoothLEPlugin.connect( function() {
		$('#debug').html( 'Connecting successfull' );
	}, function(error) {
		$('#debug').html( 'Error: ' + error );
	}, $( '#btle-devices-select' ).val() );
	
	window.localStorage.setItem("btle-device-text", $( '#btle-devices-select :selected' ).text());
	window.localStorage.setItem("btle-device-val", $( '#btle-devices-select' ).val());
}

function disconnectBTLE() {
	$('#debug').html( "disconnectBT" );
	g_bluetoothLEPlugin.disconnect( function() {
		$('#debug').html( 'Disconnectin successfull' );
	}, function(error) {
		$('#debug').html( 'Error disconnecting BT: ' + error );
	} );
}

function readBLE() {
	// $('#debug').html( "Reading..." );
	g_bluetoothLEPlugin.read( bp_readSuccessBLE, bp_readErrorBLE, $( '#btle-devices-select' ).val() );
}

function bp_readErrorBLE( error ) {
	$('#debug').html( 'Error: ' + error );
}

function bp_readSuccessBLE( p_data ) {
	// $('#debug').html( "HR: " + p_data );
	mHR = parseInt(p_data);
}
