var g_socketBT4id = -1;
var g_bluetooth4Plugin = null;
var useBT4 = false;

window.addEventListener('load', function () {
    
	document.addEventListener('deviceready', function () {
        $('#debug').html("Platform BT4 is now ready!");
		deviceVersion = device.version;
		if(deviceVersion.indexOf("-") > 0) {
			deviceVersion = deviceVersion.substring(0, deviceVersion.indexOf("-"));
		}
		// alert("Device version: "+deviceVersion);
		g_bluetooth4Plugin = cordova.require( 'cordova/plugin/bluetooth4' );
		if(window.localStorage.getItem("bt4-device-text") != null && window.localStorage.getItem("bt4-device-text") != "" && window.localStorage.getItem("bt4-device-val") != null) {
			$('#bt4-devices-select').append( $( '<option value="' + window.localStorage.getItem("bt4-device-val") + '">' + window.localStorage.getItem("bt4-device-text") + '</option>' ) );
			// setTimeout(loadOldConnectionBT4, 2000);
		} else {
			// $('#btle-devices-select').append( $( '<option value="0C:8C:DC:00:11:69">Movesense HRS</option>' ) );
		}
    }, false);
}, false);

function loadOldConnectionBT4() {
	
	g_bluetooth4Plugin.enable( function() {
		$('#debug').html( 'Enabling successfull' );
	}, function(error) {
		$('#debug').html( 'Error loadOldConnection: ' + error );
	} );
}

function enableBT4() {
	$('#debug').html( "enableBT4" );
	g_bluetooth4Plugin.enable( function() {
		$('#debug').html( 'Enabling successfull' );
		// discoverDevicesLE();
	}, function(error) {
		$('#debug').html( 'Error enabling BT4: ' + error );
	} );
}

function disableBT4() {
	$('#debug').html( "disableBT4" );
	g_bluetooth4Plugin.disable( function() {
		$('#debug').html( 'Disabling successfull' );
	}, function(error) {
		$('#debug').html( 'Error disabling BT4: ' + error );
	} );
}

function discoverDevicesBT4() {
	if(deviceVersion < "4.3") {
		alert("Bluetooth 4 is not available in your device.");
	} else {
		// $('#debug').html("Please wait, discovering devices and it may takes over 10 seconds...");
		showDialog("Please wait", "Discovering Bluetooth devices. Please wait...", 0);
		// $('#btle-devices-select').html('');
		g_bluetooth4Plugin.discoverDevices( function(devices) {
			$('#bt4-devices-select').html('');
			
			var arr = new Array();
			var j = 0;
			for( var i = 0; i < devices.length; i++ ) {
				// $('#bt-devices-select').append( $( '<option value="' + devices[i].address + '">' + devices[i].name + '</option>' ) );
				arr[j++] = devices[i].address + ';' + devices[i].name;
				useMbody = true;
				useBT4 = true;
				document.getElementById("use-mbody").className = "useYellow";
				window.localStorage.setItem("myontec-use-mbody", "1");
				window.localStorage.setItem("myontec-use-bt4", "1");
				if(devices[i].name.indexOf("MbM") == 0) {
				}
			}
			
			showBluetoothBT4Dialog(arr);
		}, function(error) { 
			$('#debug').html( 'Error discovering BT: ' + error );
			closeDialog();
			// showDialog("Please wait", 'Error: ' + error, 3000);
		});
	}
}

function discoverDevicesBT4AndConnect() {
    $('#debug').html("Please wait, discovering devices and it may takes over 2 seconds...");
	g_bluetooth4Plugin.discoverDevices( function(devices) {
		connectBT4();
    }, function(error) { 
		$('#debug').html( 'Error discovering BT: ' + error );
		closeDialog();
		// showDialog("Please wait", 'Error: ' + error, 3000);
	});
}

function pingBT4() {
	$('#debug').html( "Pinging..." );
	g_bluetooth4Plugin.ping( function(p_data) {
		$('#debug').html( 'debug: ' + p_data );
	}, function(error) {
		$('#debug').html( 'Error ping: ' + error );
	});
}

function connectBT4() {
	$('#debug').html( "Connecting BT4..." );
	g_bluetooth4Plugin.connect( function() {
		$('#debug').html( 'Connecting successfull' );
		useBT4 = true;
	}, function(error) {
		$('#debug').html( 'Error: ' + error );
	}, $( '#bt4-devices-select' ).val() );
	
	window.localStorage.setItem("bt4-device-text", $( '#bt4-devices-select :selected' ).text());
	window.localStorage.setItem("bt4-device-val", $( '#bt4-devices-select' ).val());
}

function connectBT4AndStart() {
	$('#debug').html( "Connecting BT4..." );
	g_bluetooth4Plugin.connect( function() {
		$('#debug').html( 'Connecting successfull' );
		useBT4 = true;
		debugStamp = "";
		setTimeout(myontecLoop, 400);
	}, function(error) {
		$('#debug').html( 'Error: ' + error );
	}, $( '#bt4-devices-select' ).val() );
	
	window.localStorage.setItem("bt4-device-text", $( '#bt4-devices-select :selected' ).text());
	window.localStorage.setItem("bt4-device-val", $( '#bt4-devices-select' ).val());
}

function disconnectBT4() {
	$('#debug').html( "disconnectBT4" );
	g_bluetooth4Plugin.disconnect( function() {
		$('#debug').html( 'Disconnectin successfull' );
	}, function(error) {
		$('#debug').html( 'Error disconnecting BT: ' + error );
	} );
}

function readBT4() {
	// $('#debug').html( "Reading..." );
	g_bluetooth4Plugin.read( bp_readSuccessBT4, bp_readErrorBT4, $( '#bt4-devices-select' ).val() );
}

function bp_readErrorBT4( error ) {
	$('#debug').html( 'Error: ' + error );
}

function bp_readSuccessBT4( p_data ) {
	$('#debug').html( "BT4: " + p_data );
	// alert(p_data);
	// mHR = parseInt(p_data);
}

function readBT4Mbody() {
	// $('#debug').html( "Reading..." );
	g_bluetooth4Plugin.read( bp_readSuccessBT4Mbody, bp_readErrorBT4, $( '#bt4-devices-select' ).val() );
}

var lastBT4index = "";
var debugStamp = "";
function bp_readSuccessBT4Mbody( p_data ) {
	
	if(mRunning) {
		var btdata = p_data.trim().split(" ");
		$('#debug').html( "BT4: '" + p_data + "', '"+btdata+"' length " + btdata.length + " / " + btdata[3] + " ("+lastBT4index+")");
		if(btdata.length >= 12 && lastBT4index != btdata[3]) {
			lastBT4index = btdata[3];
			var str = "Data {"+p_data+"}\n";
			if(debugStamp == "") debugStamp = createStamp();
			$('#debug').html( "BT4: " + p_data + " writing " + debugStamp );
			filewriteappend_debugdata(debugStamp, str);
			$('#debug').html( "BT4: " + p_data + " parsing" );
			myontecDataBT4(btdata);
			$('#debug').html( "BT4: " + p_data + " success" );
		}
		
		setTimeout(myontecLoop, 200);
	}
}
