
var cadSeconds = 4;
var cadMaxSampleValue = 10;

var cadences = new Array();
var smoothCadences = new Array();
var cadencesTmp = new Array();
var avgCadence = 0;

function getCurrentCadence() {
	if(smoothCadences.length > 0) return smoothCadences[smoothCadences.length-1];
	
	return 0;
}

function getCadenceAverage() {
	var sum = 0;
	var count = 0;
	for(var i = 0; i < smoothCadences.length; i++) {
		sum += getSmoothCadences(i); // smoothCadences[i];
		count++;
	}
	if(count > 0) return sum/count;
	if(avgCadence > 0) return avgCadence;
	
	return 0;
}

function getSmoothCadences(sec) {
	if(smoothCadences.length > sec && smoothCadences[sec] != null) return smoothCadences[sec];
	
	var currentCadence = countCadence(sec);
	/* if(currentCadence == 0) {
		for(var i = sec-1; i >= 0; i--) {
			if(currentCadence == 0) currentCadence = countCadence(i);
		}
	} */
	
	var cad = currentCadence;
	var count = 1;
	for(var i = 1; i < 5; i++) {
		if(sec-i >= 0 && smoothCadences[sec-i] > 0) {
			cad += smoothCadences[sec-i];
			count++;
		} else if(sec-i >= 0 && countCadence(sec-i) > 0) {
			cad += countCadence(sec-i);
			count++;
		}
	}
	smoothCadences[sec] = cad/count;
	
	/* if(sec > 3) {
		smoothCadences[sec] = (currentCadence+getSmoothCadences(sec-1)+getSmoothCadences(sec-2)+getSmoothCadences(sec-3)+getSmoothCadences(sec-4))/5;
	} else if(sec == 3) {
		smoothCadences[sec] = (currentCadence+getSmoothCadences(sec-1)+getSmoothCadences(sec-2)+getSmoothCadences(sec-3))/4;
	} else if(sec == 2) {
		smoothCadences[sec] = (currentCadence+getSmoothCadences(sec-1)+getSmoothCadences(sec-2))/3;
	} else if(sec == 1) {
		smoothCadences[sec] = (currentCadence+getSmoothCadences(sec-1))/2;
	} else {
		smoothCadences[sec] = currentCadence;
	} */
	
	return smoothCadences[sec];
}

function getCadence(sec) {
	if(sec == 1) {
		return (countCadence(sec)+countCadence(sec-1))/2;
	} else if(sec > 1) {
		var val = 0;
		var num = 0;
		if(countCadence(sec) > 0) {
			val = countCadence(sec);
			num++;
		}
		if(countCadence(sec-1) > 0) {
			val += countCadence(sec-1);
			num++;
		}
		if(countCadence(sec-2) > 0) {
			val += countCadence(sec-2);
			num++;
		}
		if(countCadence(sec-3) > 0) {
			val += countCadence(sec-3);
			num++;
		}
		if(countCadence(sec-4) > 0) {
			val += countCadence(sec-4);
			num++;
		}
		if(num == 0) return 0;
		return val/num;
	} else {
		return countCadence(sec);
	}
}

function countCadence(sec) {
	sec = parseInt(sec);
	if(cadences.length > sec && cadences[sec] != null) return cadences[sec];
	
	var dataIndex = sec*mHz;
	
	// Averaged samples
	var arr = new Array();
	for(var ch = 0; ch < mChannelCount; ch++) {
		arr[ch] = new Array();
		
		var ii = 0;
		for(var i = 0; i < cadSeconds*mHz; i++) {
			var index = dataIndex-cadSeconds*mHz+i;
			if(index > 1) {
				arr[ch][ii++] = (mData[ch][index]+mData[ch][index-1]+mData[ch][index-2])/3;
			} else if(index == 1) {
				arr[ch][ii++] = (mData[ch][index]+mData[ch][index-1])/2;
			} else {
				arr[ch][ii++] = mData[ch][index];
			}
			// arr[ch][ii-1] = mData[ch][index];
			if(parseInt(arr[ch][ii-1])+"" == "NaN") arr[ch][ii-1] = 0;
		}
	}
	// Medians
	var medians = new Array();
	var maxValue = 0;
	for(var ch = 0; ch < mChannelCount; ch++) {
		var arr2 = new Array();
		for(var i = 0; i < arr[ch].length; i++) {
			arr2[i] = arr[ch][i];
		}
		for(var i = 0; i < arr2.length-1; i++) {
			for(var j = i+1; j < arr2.length; j++) {	
				if(arr2[j] < arr2[i]) {
					var tmp = arr2[i];
					arr2[i] = arr2[j];
					arr2[j] = tmp;
				}
			}
		}
		if(arr2.length > 0) medians[ch] = arr2[parseInt(arr2.length/2)];
		else medians[ch] = 0;
		// if(ch == 0) document.getElementById("debug3").innerHTML += medians[ch]+"; ";
		if(arr2.length > 0 && arr2[arr2.length-1] > maxValue) maxValue = arr2[arr2.length-1];
	}
	// document.getElementById("debug3").innerHTML += "maxValue "+maxValue+", ";
	var cadence = 0;
	cadencesTmp[sec] = "max"+parseInt(maxValue);
	if(maxValue > cadMaxSampleValue) {
		// Normalizes
		for(var ch = 0; ch < mChannelCount; ch++) {
			for(var i = 0; i < arr[ch].length; i++) {
				if(medians[ch] > 0) arr[ch][i] = arr[ch][i]/medians[ch];
			}
		}
		// Find peaks and calculate cadences per channel
		var cads = new Array();
		cadencesTmp[sec] = "";
		for(var ch = 0; ch < mChannelCount; ch++) {
			var peaks = new Array();
			var lastPeak = 0;
			var relaxFound = true;
			var thresholdAmplitude = 1.6;
			var relaxThreshold = 0.9;
			var samplesBetweenPeaks = 9;
			if(ch == 1) {
				for(var i = 0; i < arr[ch].length; i++) {
					cadencesTmp[sec] += " "+parseInt(arr[ch][i]*10)/10;
				}
			}
			for(var i = 1; i < arr[ch].length-1; i++) {
				if(arr[ch][i] > thresholdAmplitude) {
					if(arr[ch][i] > arr[ch][i-1] && arr[ch][i] > arr[ch][i+1]) {
						if (((i-lastPeak) - samplesBetweenPeaks) > 0 && relaxFound) {
							if(lastPeak > 0) {
								peaks[peaks.length] = (i-lastPeak) * (1000.0/mHz);
								// cadencesTmp[sec] += (i-lastPeak)+" ";
							}
							// if(ch == 0 && sec == 10) document.getElementById("debug3").innerHTML += ch+" "+i+" "+parseInt((i-lastPeak) * (1000.0/mHz))+" / ";
							lastPeak = i;
							relaxFound = false;
						}
					}
				} else if(arr[ch][i] < relaxThreshold) {
					relaxFound = true;
				}
			}
			// cadencesTmp[sec] += " / ";
			var averagePeak = 0;
			// if(sec == 103) document.getElementById("debug3").innerHTML += " | "+ch+": ";
			if(peaks.length > 0) {
				for(var i = 0; i < peaks.length; i++) {
					averagePeak += peaks[i];
					// if(sec == 103) document.getElementById("debug3").innerHTML += peaks[i]+", ";
				}
				averagePeak /= peaks.length;
			}
			// Take median, not average / Jariha 8.6.2014
			for(var i = 0; i < peaks.length-1; i++) {
				for(var j = i+1; j < peaks.length; j++) {	
					if(peaks[j] < peaks[i]) {
						var tmp = peaks[i];
						peaks[i] = peaks[j];
						peaks[j] = tmp;
					}
				}
			}
			if(peaks.length > 0) averagePeak = peaks[parseInt(peaks.length/2)];

			// document.getElementById("debug3").innerHTML += sec+" "+peaks.length+" "+parseInt(averagePeak)+", ";
			if(averagePeak > 0) {
				cads[ch] = Math.round(1000.0/averagePeak*60);
			} else {
				cads[ch] = 0;
			}
		}
		
		// Find cadences
		var diff = 7;
		var limitMin = 20;
		var limitMax0 = 100;
		var limitMax = 180;
		if(cads.length >= 4) {
			cadence = 0;
			/* if((cads[2]+diff) > cads[3] && (cads[2]-diff) < cads[3]) {
			// if(Math.abs(cads[2]-cads[3]) < diff) {
				var cad = parseInt((cads[2] + cads[3])/2);
				if(cad > limitMin && cad < limitMax) {
				// if(cad < limitMax) {
					cadence = cad;
					// document.getElementById("debug3").innerHTML += " b"+sec+" "+cadence;
				}
			} */
			if(cadence == 0) {
				if((cads[0]+diff) > cads[1] && (cads[0]-diff) < cads[1]) {
				// if(Math.abs(cads[0]-cads[1]) < diff) {
					var cad = parseInt((cads[0] + cads[1])/2);
					if(cad > limitMin && cad < limitMax0) {
					// if(cad < limitMax) {
						cadence = cad;
						// document.getElementById("debug3").innerHTML += " a"+sec+" "+cadence;
					}
				}
			}
			if(cadence == 0) {
				if((cads[2]+diff) > cads[3] && (cads[2]-diff) < cads[3]) {
				// if(Math.abs(cads[2]-cads[3]) < diff) {
					var cad = parseInt((cads[2] + cads[3])/2);
					if(cad < limitMax) {
						cadence = cad;
						// document.getElementById("debug3").innerHTML += " b"+sec+" "+cadence;
					}
				}
			}
			// cadencesTmp[sec] = "["+cadence+"] "+cads[0]+","+cads[1]+","+cads[2]+","+cads[3];
			// cadence = (medians[ch]);
		// if(sec == 103) document.getElementById("debug3").innerHTML += " || "+cads[0]+", "+cads[1]+", "+cads[2]+", "+cads[3];
		}
	}
	// if(sec == 103) document.getElementById("debug3").innerHTML += " || "+cadence;
	cadences[sec] = cadence;
	
	return cadences[sec];
}

function clearCadences() {
	cadences = new Array();
	smoothCadences = new Array();
	avgCadence = 0;
}