var gpsStatus = 0;
var gpsWatchId = 0;
var gpsTimestamp = 0;
var gpsLatitude = 0;
var gpsLongitude = 0;
var gpsAltitude = 0;
var gpsSpeed = 0;
var gpsDistance = 0;
var gpsClientTime = 0;

function gpsInit()
{
    if( navigator.geolocation ) {
		gpsStatus = 1;
		if(gpsWatchId == 0) {
             gpsWatchId = navigator.geolocation.watchPosition(geolocationPosition,geolocationFail,{enableHighAccuracy:true, maximumAge:0});
             console_log("Initialize GPS");
		}
	} else {
		alert("Cannot initialize GPS. Please, check settings.");
		gpsStatus = -1;
	}
}

function geolocationClear() 
{
	if(gpsWatchId != 0) {
        console_log("disable GPS");
		navigator.geolocation.clearWatch(gpsWatchId);
		gpsWatchId = 0;
	}
	gpsStatus = 0;
}

function geolocationPosition(p) {
	// console_log("GPS position");
    if(p.coords.accuracy < 100 && p.coords.speed >= 0) {
    // if(p.coords.accuracy < 200) {
        gpsStatus = 2;
		gpsClientTime = new Date().getTime();
		
		gpsLatitude = p.coords.latitude;
		gpsLongitude = p.coords.longitude;
		gpsAltitude = p.coords.altitude;
		gpsSpeed = p.coords.speed*3.6;
		
		var time0 = geolocationTimestamp(gpsTimestamp);
		var time1 = geolocationTimestamp(p.timestamp);
		if(time0 > 0 && time1 > 0) {
			var d = Math.abs(p.coords.speed*((time0-time1)/1000.0));
			if(d < 40) {
				gpsDistance += d;
			}
		}
		
        gpsTimestamp = new Date().getTime(); // geolocationTimestamp(p.timestamp);
        // console_log(p.timestamp+" --- "+gpsTimestamp);
		// doPosition(p);
	}
    if(p != null && p.coords != null) console_log(p.coords.latitude+", "+p.coords.longitude+", "+p.coords.altitude+", "+p.coords.speed+", "+p.coords.accuracy);
}

function geolocationInitFail(error) {
	gpsStatus = 0;
    console_log("GPS init failed");
	alert(error.code + " - " + error.message);
}

function geolocationFail(error) {
	gpsStatus = 0;
    console_log("GPS error: "+error.code + " - " + error.message);
	// alert(error.code + " - " + error.message);
}

function geolocationTimestamp(ts) {
    if (ts > 14000000000000) {
		ts = Math.floor(ts / 1000);
	} else {
		// ts *= 1000;
	}
    return ts;
}
