
var graphPaddingTop = 45;
var graphPaddingLeft = 70;

var smoothval = new Array();

var color_active = "#ffdd00";
var color_alert = "#dd0000";
var color_passive = "#808080";
var color_value = "#ffffff";
var color_label = "#a0a0a0";
var color_title = "#ffdd00";
var color_background = "#000000";
var color_line = "#ffdd00";
var color_yellow = "#ffdd00";
var color_meter = "";

function setTheme(theme) {
	if(theme == null) {
		theme = document.getElementById("theme").value;
	}
	if(theme == "white") {
		document.body.style.backgroundColor = "#ffffff";
		color_active = "#ddaa00";
		color_passive = "#d0d0d0";
		color_value = "#000000";
		color_label = "#808080";
		color_title = "#000000";
		color_background = "#ffffff";
		color_line = "#808080";
		color_meter = "white";
	} else {
		document.body.style.backgroundColor = "#000000";
		color_active = "#ffdd00";
		color_passive = "#585858";
		color_value = "#ffffff";
		color_label = "#a0a0a0";
		color_title = "#a6a6a6";
		color_background = "#000000";
		color_line = "#585858";
		color_meter = "";
	}
	window.localStorage.setItem("myontec-theme", theme);
}

function tweakCanvas(name) {
	// Tweak the canvas opacity, causing it to redraw
	$(name).css('opacity', '0.99');
	// Set the canvas opacity back to normal after 5ms
	setTimeout(function() {
		$(name).css('opacity', '1');
	}, 5);
}

function showBackground(name) {
	
	try {
		var context = document.getElementById(name).getContext("2d");
		
		var width = document.getElementById(name).width;
		var height = document.getElementById(name).height;
		
		context.fillStyle = "#000000";
		context.fillRect(0, 0, width, height);
		
		var bg = document.getElementById("meter-bg");
		context.drawImage(bg, 0, 0, width, height);
	} catch(err) {
		alert(err.message);
	}
}

function showBackgroundImage(name, img) {
	
	try {
		var context = document.getElementById(name).getContext("2d");
		
		var width = document.getElementById(name).width;
		var height = document.getElementById(name).height;
		
		context.fillStyle = "#000000";
		context.fillRect(0, 0, width, height);
		
		var bg = document.getElementById(img);
		context.drawImage(bg, 0, 0, width, height);
	} catch(err) {
		alert(err.message);
	}
}

function showNone(name) {
	
	var context = document.getElementById(name).getContext("2d");
	context.clearRect(0,0,document.getElementById(name).width,document.getElementById(name).height);
}

function showMeter(name, title, prefix, value, min, max, desimals) {
	
	/* var nro = parseInt(name.substring(5));
	if(isNaN(value)) value = 0;
	if(smoothval[nro] != null) {
		var step = (max-min) / 50.0;
		if(value > smoothval[nro]+step) smoothval[nro] += step;
		else if(value < smoothval[nro]-step) smoothval[nro] -= step;
		
		value = smoothval[nro];
	} else {
		smoothval[nro] = value;
	} */
	
	// document.getElementById(name).width = document.getElementById(name).width;
	var context = document.getElementById(name).getContext("2d");
	context.clearRect(0,0,document.getElementById(name).width,document.getElementById(name).height);
	
	var width = document.getElementById(name).width;
	var height = document.getElementById(name).height;
	
	if(value+"" == "NaN") value = 0;
	
	if(height < width && height == 240) {
		
		context.fillStyle = color_background;
		context.fillRect(0, 0, width, height);
		
		var bg = document.getElementById("meter220-bg");
		context.drawImage(bg, 0, 0, width, height);
		
		if(value != "Average" && title != "Sport") {
			if(desimals != 0) {
				value = parseFloat(value).toFixed(desimals)+"";
				value = value.replace(".", ",");
			} else {
				value = Math.round(value);
			}
		}
		if(parseInt(value) > 10000000) value = 0;
		
		var scale = width/360;
		var fontScale = 0.55;
		
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(32*fontScale))+"pt Sans-serif";
		if(name == "meter2" || name == "meter12" || name == "meter22" || name == "meter32") {
			context.fillStyle = color_line;
			context.beginPath();
			context.moveTo(width-42, height-8);
			context.lineTo(width-27, height-23);
			context.lineTo(width-27, height-8);
			context.closePath();
			context.fill();
			// context.fillRect(0, height-8, width-40, 1);
			context.fillStyle = color_yellow;
			context.fillText(title, 40, 0);
			
			context.textAlign = "left";
			if(value == "Not specified") {
				context.font = "bold "+(parseInt(48*fontScale))+"pt Sans-serif";
			} else if(value == "Mountain biking") {
				context.font = "bold "+(parseInt(40*fontScale))+"pt Sans-serif";
			} else {
				context.font = "bold "+(parseInt(48*fontScale))+"pt Sans-serif";
			}
			context.fillStyle = color_value;
			if(value == 1) {
				context.fillText("Real time", 40, 30);
			} else if(prefix != "") {
				context.fillText(value+" "+prefix, 40, 30);
			} else {
				context.fillText(value, 40, 30);
			}
		} else {
			context.fillStyle = color_line;
			context.beginPath();
			context.moveTo(width-42, height-8);
			context.lineTo(width-27, height-23);
			context.lineTo(width-27, height-8);
			context.closePath();
			context.fill();
			// context.fillRect(0, 2, width-40, 1);
			
			context.fillStyle = color_yellow;
			// context.fillText(title, 0, 0);
			var avg = "";
			if(title.indexOf(" avg") > 0) {
				title = title.replace(" avg", "");
				avg = "AVG";
			}
			context.fillText(title, 40, 10);
			var w = context.measureText(title+" ").width;
			context.font = "bold "+(parseInt(24*fontScale))+"pt Sans-serif";
			context.fillText(avg, w+40, 24);
			
			context.textAlign = "center";
			context.font = "bold "+(parseInt(120*fontScale))+"pt Sans-serif";
			context.fillStyle = color_value;
			if(value == 0 || value == "0,0") context.fillText("-", 170, 60);
			else context.fillText(value, 170, 60);
			
			context.font = "bold "+(parseInt(40*fontScale))+"pt Sans-serif";
			context.fillStyle = color_label;
			context.fillText(prefix, 170, 180);
		}
	} else if(height < width) {
		
		context.fillStyle = color_background;
		context.fillRect(0, 0, width, height);
		
		if(value != "Average" && title != "Sport") {
			if(desimals != 0) {
				value = parseFloat(value).toFixed(desimals)+"";
				value = value.replace(".", ",");
			} else {
				value = Math.round(value);
			}
		}
		if(parseInt(value) > 10000000) value = 0;
		
		var scale = width/360;
		var fontScale = 0.55;
		
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(32*fontScale))+"pt Sans-serif";
		if(name == "meter2" || name == "meter12" || name == "meter22" || name == "meter32") {
			context.fillStyle = color_line;
			context.beginPath();
			context.moveTo(width-42, height-8);
			context.lineTo(width-27, height-23);
			context.lineTo(width-27, height-8);
			context.closePath();
			context.fill();
			// context.fillRect(0, height-8, width-40, 1);
			if(name == "meter2" || name == "meter12" || name == "meter22" || name == "meter32") context.fillStyle = color_title;
			else context.fillStyle = color_yellow;
			context.fillText(title, 40, 0);
			
			context.textAlign = "left";
			var bigTextTop = 0;
			if(value == "Not specified sport") {
				context.font = "bold "+(parseInt(36*fontScale))+"pt Sans-serif";
				bigTextTop = 6;
			} else if(value == "Crosscountry skiing") {
				context.font = "bold "+(parseInt(36*fontScale))+"pt Sans-serif";
				bigTextTop = 6;
			} else if(value == "Mountain biking") {
				context.font = "bold "+(parseInt(40*fontScale))+"pt Sans-serif";
				bigTextTop = 2;
			} else {
				context.font = "bold "+(parseInt(48*fontScale))+"pt Sans-serif";
			}
			context.fillStyle = color_value;
			if(value == 1) {
				context.fillText("Real time", 40, 30);
			} else if(prefix != "") {
				// context.fillText(value+" "+prefix, 0, 30);
				context.fillText(value, 40, 30+bigTextTop);
				var w = context.measureText(value+" ").width;
				context.fillStyle = color_label;
				context.font = "bold "+(parseInt(36*fontScale))+"pt Sans-serif";
				context.fillText(prefix, w+40, 30+30*fontScale);
			} else {
				context.fillText(value, 40, 30+bigTextTop);
			}
		} else {
			context.fillStyle = color_line;
			context.beginPath();
			context.moveTo(width-42, height-8);
			context.lineTo(width-27, height-23);
			context.lineTo(width-27, height-8);
			context.closePath();
			context.fill();
			// context.fillRect(0, 2, width-40, 1);
			
			if(name == "meter2" || name == "meter12") context.fillStyle = color_title;
			else context.fillStyle = color_yellow;
			// context.fillText(title, 0, 0);
			var avg = "";
			if(title.indexOf(" avg") > 0) {
				title = title.replace(" avg", "");
				avg = "AVG";
			}
			context.fillText(title, 40, 0);
			var w = context.measureText(title+" ").width;
			context.font = "bold "+(parseInt(24*fontScale))+"pt Sans-serif";
			context.fillText(avg, w+40, 14);
			
			context.textAlign = "left";
			context.font = "bold "+(parseInt(60*fontScale))+"pt Sans-serif";
			context.fillStyle = color_value;
			if(name == 'meter2' && value == 1) {
				context.fillText("Real time", 40, 30);
			} else if(prefix != "") {
				// context.fillText(value+" "+prefix, 0, 30);
				context.fillText(value, 40, 30);
				var w = context.measureText(value+" ").width;
				context.fillStyle = color_label;
				context.font = "bold "+(parseInt(36*fontScale))+"pt Sans-serif";
				context.fillText(prefix, w+40, 30+30*fontScale);
			} else {
				context.fillText(value, 40, 30);
			}
		}
	} else {
		
		context.fillStyle = color_passive;
		context.fillRect(0, 0, width, height);
		
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(0, 0, width, height);
		} else if(value > min) {
			var angle = (value-min)/(max-min)-90/360;
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(width/2, 0);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			if(cos > width/2) {
				context.lineTo(width, sin);
				context.lineTo(width, 0);
			} else if(sin > width/2) {
				context.lineTo(cos, height);
				context.lineTo(width, height);
				context.lineTo(width, sin);
				context.lineTo(width, 0);
			} else {
				context.lineTo(0, sin);
				context.lineTo(0, height);
				context.lineTo(width, height);
				context.lineTo(width, sin);
				context.lineTo(width, 0);
			}
			
			context.closePath();
			context.fill();
		}
		
		var bg = document.getElementById("meter-img"+color_meter+"1");
		context.drawImage(bg, 0, 0, width, height);
		
		if(desimals != 0) {
			value = parseFloat(value).toFixed(desimals)+"";
			value = value.replace(".", ",");
		} else {
			value = Math.round(value);
		}
		
		var scale = width/360;
		var fontScale = scale;
		
		context.textBaseline = "top";
		context.textAlign = "center";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
		else context.fillStyle = color_yellow;
		context.fillText(title, 180*scale, 5*scale);
		
		context.font = "bold "+(parseInt(60*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		if(value == "1 s") context.fillText("Real time", 180*scale, 138*scale);
		else context.fillText(value, 180*scale, 138*scale);
		
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText(prefix, 180*scale, 227*scale);
	}
}

function showPaceMeter(name, title, prefix, value, min, max, desimals) {
	
	/* var nro = parseInt(name.substring(5));
	if(isNaN(value)) value = 0;
	if(smoothval[nro] != null) {
		var step = (max-min) / 50.0;
		if(value > smoothval[nro]+step) smoothval[nro] += step;
		else if(value < smoothval[nro]-step) smoothval[nro] -= step;
		
		value = smoothval[nro];
	} else {
		smoothval[nro] = value;
	} */
	
	// document.getElementById(name).width = document.getElementById(name).width;
	var context = document.getElementById(name).getContext("2d");
	context.clearRect(0,0,document.getElementById(name).width,document.getElementById(name).height);
	
	var width = document.getElementById(name).width;
	var height = document.getElementById(name).height;
	
	if(value+"" == "NaN") value = 0;
	
	if(height < width && height == 240) {
		
		context.fillStyle = color_background;
		context.fillRect(0, 0, width, height);
		
		var bg = document.getElementById("meter220-bg");
		context.drawImage(bg, 0, 0, width, height);
		
		if(value != "Average" && title != "Sport") {
			if(desimals != 0) {
				value = parseFloat(value).toFixed(desimals)+"";
				value = value.replace(".", ",");
			} else {
				value = Math.round(value);
			}
		}
		if(parseInt(value) > 10000000) value = 0;
		
		var scale = width/360;
		var fontScale = 0.55;
		
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(32*fontScale))+"pt Sans-serif";
		if(name == "meter2" || name == "meter12" || name == "meter22" || name == "meter32") {
			context.fillStyle = color_line;
			context.beginPath();
			context.moveTo(width-42, height-8);
			context.lineTo(width-27, height-23);
			context.lineTo(width-27, height-8);
			context.closePath();
			context.fill();
			// context.fillRect(0, height-8, width-40, 1);
			context.fillStyle = color_yellow;
			context.fillText(title, 40, 0);
			
			context.textAlign = "left";
			if(value == "Not specified") {
				context.font = "bold "+(parseInt(48*fontScale))+"pt Sans-serif";
			} else if(value == "Mountain biking") {
				context.font = "bold "+(parseInt(40*fontScale))+"pt Sans-serif";
			} else {
				context.font = "bold "+(parseInt(48*fontScale))+"pt Sans-serif";
			}
			context.fillStyle = color_value;
			if(value == 1) {
				context.fillText("Real time", 40, 30);
			} else if(prefix != "") {
				context.fillText(value+" "+prefix, 40, 30);
			} else {
				context.fillText(value, 40, 30);
			}
		} else {
			context.fillStyle = color_line;
			context.beginPath();
			context.moveTo(width-42, height-8);
			context.lineTo(width-27, height-23);
			context.lineTo(width-27, height-8);
			context.closePath();
			context.fill();
			// context.fillRect(0, 2, width-40, 1);
			
			context.fillStyle = color_yellow;
			// context.fillText(title, 0, 0);
			var avg = "";
			if(title.indexOf(" avg") > 0) {
				title = title.replace(" avg", "");
				avg = "AVG";
			}
			context.fillText(title, 40, 10);
			var w = context.measureText(title+" ").width;
			context.font = "bold "+(parseInt(24*fontScale))+"pt Sans-serif";
			context.fillText(avg, w+40, 24);
			
			context.textAlign = "center";
			context.font = "bold "+(parseInt(120*fontScale))+"pt Sans-serif";
			context.fillStyle = color_value;
			if(value == 0 || value == "0,0") context.fillText("-", 170, 60);
			else {
				value += ",0";
				var vals = value.split(",");
				var str2 = vals[1].substring(0,2);
				var val2 = parseInt(vals[1]);
				if(str2.length == 1) val2 = val2*10;
				val2 = parseInt(val2*0.6);
				if(val2 < 10) val2 = "0"+val2;
				context.fillText(vals[0]+"'"+val2, 170, 60);
				// context.fillText(value, 170, 60);
			}
			
			context.font = "bold "+(parseInt(40*fontScale))+"pt Sans-serif";
			context.fillStyle = color_label;
			context.fillText(prefix, 170, 180);
		}
	} else if(height < width) {
		
		context.fillStyle = color_background;
		context.fillRect(0, 0, width, height);
		
		if(value != "Average" && title != "Sport") {
			if(desimals != 0) {
				value = parseFloat(value).toFixed(desimals)+"";
				value = value.replace(".", ",");
			} else {
				value = Math.round(value);
			}
		}
		if(parseInt(value) > 10000000) value = 0;
		
		var scale = width/360;
		var fontScale = 0.55;
		
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(32*fontScale))+"pt Sans-serif";
		if(name == "meter2" || name == "meter12" || name == "meter22" || name == "meter32") {
			context.fillStyle = color_line;
			context.beginPath();
			context.moveTo(width-42, height-8);
			context.lineTo(width-27, height-23);
			context.lineTo(width-27, height-8);
			context.closePath();
			context.fill();
			// context.fillRect(0, height-8, width-40, 1);
			if(name == "meter2" || name == "meter12" || name == "meter22" || name == "meter32") context.fillStyle = color_title;
			else context.fillStyle = color_yellow;
			context.fillText(title, 40, 0);
			
			context.textAlign = "left";
			var bigTextTop = 0;
			if(value == "Not specified sport") {
				context.font = "bold "+(parseInt(36*fontScale))+"pt Sans-serif";
				bigTextTop = 6;
			} else if(value == "Crosscountry skiing") {
				context.font = "bold "+(parseInt(36*fontScale))+"pt Sans-serif";
				bigTextTop = 6;
			} else if(value == "Mountain biking") {
				context.font = "bold "+(parseInt(40*fontScale))+"pt Sans-serif";
				bigTextTop = 2;
			} else {
				context.font = "bold "+(parseInt(48*fontScale))+"pt Sans-serif";
			}
			context.fillStyle = color_value;
			if(value == 1) {
				context.fillText("Real time", 40, 30);
			} else if(prefix != "") {
				// context.fillText(value+" "+prefix, 0, 30);
				context.fillText(value, 40, 30+bigTextTop);
				var w = context.measureText(value+" ").width;
				context.fillStyle = color_label;
				context.font = "bold "+(parseInt(36*fontScale))+"pt Sans-serif";
				context.fillText(prefix, w+40, 30+30*fontScale);
			} else {
				context.fillText(value, 40, 30+bigTextTop);
			}
		} else {
			context.fillStyle = color_line;
			context.beginPath();
			context.moveTo(width-42, height-8);
			context.lineTo(width-27, height-23);
			context.lineTo(width-27, height-8);
			context.closePath();
			context.fill();
			// context.fillRect(0, 2, width-40, 1);
			
			if(name == "meter2" || name == "meter12") context.fillStyle = color_title;
			else context.fillStyle = color_yellow;
			// context.fillText(title, 0, 0);
			var avg = "";
			if(title.indexOf(" avg") > 0) {
				title = title.replace(" avg", "");
				avg = "AVG";
			}
			context.fillText(title, 40, 0);
			var w = context.measureText(title+" ").width;
			context.font = "bold "+(parseInt(24*fontScale))+"pt Sans-serif";
			context.fillText(avg, w+40, 14);
			
			context.textAlign = "left";
			context.font = "bold "+(parseInt(60*fontScale))+"pt Sans-serif";
			context.fillStyle = color_value;
			if(name == 'meter2' && value == 1) {
				context.fillText("Real time", 40, 30);
			} else if(prefix != "") {
				// context.fillText(value+" "+prefix, 0, 30);
				context.fillText(value, 40, 30);
				var w = context.measureText(value+" ").width;
				context.fillStyle = color_label;
				context.font = "bold "+(parseInt(36*fontScale))+"pt Sans-serif";
				context.fillText(prefix, w+40, 30+30*fontScale);
			} else {
				context.fillText(value, 40, 30);
			}
		}
	} else {
		
		context.fillStyle = color_passive;
		context.fillRect(0, 0, width, height);
		
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(0, 0, width, height);
		} else if(value > min) {
			var angle = (value-min)/(max-min)-90/360;
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(width/2, 0);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			if(cos > width/2) {
				context.lineTo(width, sin);
				context.lineTo(width, 0);
			} else if(sin > width/2) {
				context.lineTo(cos, height);
				context.lineTo(width, height);
				context.lineTo(width, sin);
				context.lineTo(width, 0);
			} else {
				context.lineTo(0, sin);
				context.lineTo(0, height);
				context.lineTo(width, height);
				context.lineTo(width, sin);
				context.lineTo(width, 0);
			}
			
			context.closePath();
			context.fill();
		}
		
		var bg = document.getElementById("meter-img"+color_meter+"1");
		context.drawImage(bg, 0, 0, width, height);
		
		if(desimals != 0) {
			value = parseFloat(value).toFixed(desimals)+"";
			value = value.replace(".", ",");
		} else {
			value = Math.round(value);
		}
		
		var scale = width/360;
		var fontScale = scale;
		
		context.textBaseline = "top";
		context.textAlign = "center";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
		else context.fillStyle = color_yellow;
		context.fillText(title, 180*scale, 5*scale);
		
		context.font = "bold "+(parseInt(60*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		if(value == "1 s") context.fillText("Real time", 180*scale, 138*scale);
		else context.fillText(value, 180*scale, 138*scale);
		
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText(prefix, 180*scale, 227*scale);
	}
}

function showLimitMeter(name, title, prefix, value, min, limit, max, desimals) {
	
	/* var nro = parseInt(name.substring(5));
	if(isNaN(value)) value = 0;
	if(smoothval[nro] != null) {
		var step = (max-min) / 50.0;
		if(value > smoothval[nro]+step) smoothval[nro] += step;
		else if(value < smoothval[nro]-step) smoothval[nro] -= step;
		
		value = smoothval[nro];
	} else {
		smoothval[nro] = value;
	} */
	
	// document.getElementById(name).width = document.getElementById(name).width;
	var context = document.getElementById(name).getContext("2d");
	context.clearRect(0,0,document.getElementById(name).width,document.getElementById(name).height);
	
	var width = document.getElementById(name).width;
	var height = document.getElementById(name).height;
	
	if(value+"" == "NaN") value = 0;
	
	if(height < width && height == 240) {
		
		context.fillStyle = color_background;
		context.fillRect(0, 0, width, height);
		
		var bg = document.getElementById("meter220-bg");
		context.drawImage(bg, 0, 0, width, height);
		
		if(value != "Average" && title != "Sport") {
			if(desimals != 0) {
				value = parseFloat(value).toFixed(desimals)+"";
				value = value.replace(".", ",");
			} else {
				value = Math.round(value);
			}
		}
		if(parseInt(value) > 10000000) value = 0;
		
		var scale = width/360;
		var fontScale = 0.55;
		
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(32*fontScale))+"pt Sans-serif";
		if(name == "meter2" || name == "meter12" || name == "meter22") {
			context.fillStyle = color_line;
			context.beginPath();
			context.moveTo(width-42, height-8);
			context.lineTo(width-27, height-23);
			context.lineTo(width-27, height-8);
			context.closePath();
			context.fill();
			// context.fillRect(0, height-8, width-40, 1);
			if(name == "meter02" || name == "meter12" || name == "meter22") context.fillStyle = color_title;
			else context.fillStyle = color_yellow;
			context.fillText(title, 40, 0);
			
			context.textAlign = "left";
			if(value == "Not specified") {
				context.font = "bold "+(parseInt(48*fontScale))+"pt Sans-serif";
			} else {
				context.font = "bold "+(parseInt(60*fontScale))+"pt Sans-serif";
			}
			context.fillStyle = color_value;
			if(value == 1) {
				context.fillText("Real time", 40, 30);
			} else if(prefix != "") {
				context.fillText(value+" "+prefix, 40, 340);
			} else {
				context.fillText(value, 40, 30);
			}
		} else {
			context.fillStyle = color_line;
			context.beginPath();
			context.moveTo(width-42, height-8);
			context.lineTo(width-27, height-23);
			context.lineTo(width-27, height-8);
			context.closePath();
			context.fill();
			// context.fillRect(0, 2, width-40, 1);
			
			if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
			else context.fillStyle = color_yellow;
			// context.fillText(title, 0, 0);
			var avg = "";
			if(title.indexOf(" avg") > 0) {
				title = title.replace(" avg", "");
				avg = "AVG";
			}
			context.fillText(title, 40, 10);
			var w = context.measureText(title+" ").width;
			context.font = "bold "+(parseInt(24*fontScale))+"pt Sans-serif";
			context.fillText(avg, w+40, 24);
			
			context.textAlign = "center";
			context.font = "bold "+(parseInt(120*fontScale))+"pt Sans-serif";
			context.fillStyle = color_value;
			if(value == 0 || value == "0,0") context.fillText("-", 170, 60);
			else context.fillText(value, 170, 60);
			
			context.font = "bold "+(parseInt(40*fontScale))+"pt Sans-serif";
			context.fillStyle = color_label;
			context.fillText(prefix, 170, 180);
		}
	} else if(height < width) {
		
		context.fillStyle = color_background;
		context.fillRect(0, 0, width, height);
		
		if(value != "Average" && title != "Sport") {
			if(desimals != 0) {
				value = parseFloat(value).toFixed(desimals)+"";
				value = value.replace(".", ",");
			} else {
				value = Math.round(value);
			}
		}
		if(parseInt(value) > 10000000) value = 0;
		
		var scale = width/360;
		var fontScale = 0.55;
		
		// prefix = prefix.replace("MA/min", "MA");
		
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(32*fontScale))+"pt Sans-serif";
		if(name == "meter2" || name == "meter12" || name == "meter22") {
			context.fillStyle = color_line;
			context.beginPath();
			context.moveTo(width-42, height-8);
			context.lineTo(width-27, height-23);
			context.lineTo(width-27, height-8);
			context.closePath();
			context.fill();
			// context.fillRect(0, height-8, width-40, 1);
			if(name == "meter02" || name == "meter12" || name == "meter22") context.fillStyle = color_title;
			else context.fillStyle = color_yellow;
			context.fillText(title, 40, 0);
			
			context.textAlign = "left";
			if(value == "Not specified") {
				context.font = "bold "+(parseInt(48*fontScale))+"pt Sans-serif";
			} else {
				context.font = "bold "+(parseInt(60*fontScale))+"pt Sans-serif";
			}
			context.fillStyle = color_value;
			if(value == 1) {
				context.fillText("Real time", 40, 30);
			} else if(prefix != "") {
				// context.fillText(value+" "+prefix, 0, 30);
				context.fillText(value, 40, 30);
				var w = context.measureText(value+" ").width;
				context.fillStyle = color_label;
				context.font = "bold "+(parseInt(36*fontScale))+"pt Sans-serif";
				context.fillText(prefix, w+40, 30+30*fontScale);
			} else {
				context.fillText(value, 40, 30);
			}
		} else {
			context.fillStyle = color_line;
			context.beginPath();
			context.moveTo(width-42, height-8);
			context.lineTo(width-27, height-23);
			context.lineTo(width-27, height-8);
			context.closePath();
			context.fill();
			// context.fillRect(0, 2, width-40, 1);
			
			if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
			else context.fillStyle = color_yellow;
			// context.fillText(title, 0, 0);
			var avg = "";
			if(title.indexOf(" avg") > 0) {
				title = title.replace(" avg", "");
				avg = "AVG";
			}
			context.fillText(title, 40, 0);
			var w = context.measureText(title+" ").width;
			context.font = "bold "+(parseInt(24*fontScale))+"pt Sans-serif";
			context.fillText(avg, w+40, 14);
			
			context.textAlign = "left";
			context.font = "bold "+(parseInt(60*fontScale))+"pt Sans-serif";
			context.fillStyle = color_value;
			if(name == 'meter2' && value == 1) {
				context.fillText("Real time", 40, 30);
			} else if(prefix != "") {
				// context.fillText(value+" "+prefix, 0, 30);
				context.fillText(value, 40, 30);
				var w = context.measureText(value+" ").width;
				context.fillStyle = color_label;
				context.font = "bold "+(parseInt(36*fontScale))+"pt Sans-serif";
				context.fillText(prefix, w+40, 30+30*fontScale);
			} else {
				context.fillText(value, 40, 30);
			}
		}
	} else {
		
		context.fillStyle = color_passive;
		context.fillRect(0, 0, width, height);
		
		var max2 = max;
		if( value == 0 ) {
		
		} else if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(0, 0, width, height);
			context.fillStyle = color_alert;
			context.fillRect(0, 0, width/2, height/2);
		} else if( value > limit ) {
			context.fillStyle = color_active;
			context.fillRect(0, 0, width, height);
			context.fillStyle = color_passive;
			context.fillRect(0, 0, width/2, height/2);
			
			var angle = ((value-limit)/(max-limit)/4+180/360); // +(0.75*Math.PI*2);
			// alert("Angle: "+angle+" v"+value+" l"+limit+" m"+max);
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_alert;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(width/2, height/2);
			context.lineTo(cos, sin);
			context.lineTo(0, 0);
			context.lineTo(0, height/2);
			context.lineTo(width/2, height/2);
			
			context.closePath();
			context.fill();
		} else {
			max = limit / 0.75;
			var angle = (value-min)/(max-min)-90/360;
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(width/2, 0);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			if(cos > width/2) {
				context.lineTo(width, sin);
				context.lineTo(width, 0);
			} else if(sin > width/2) {
				context.lineTo(cos, height);
				context.lineTo(width, height);
				context.lineTo(width, sin);
				context.lineTo(width, 0);
			} else {
				context.lineTo(0, sin);
				context.lineTo(0, height);
				context.lineTo(width, height);
				context.lineTo(width, sin);
				context.lineTo(width, 0);
			}
			
			context.closePath();
			context.fill();
		}
		
		var bg = document.getElementById("meter-img"+color_meter+"1");
		context.drawImage(bg, 0, 0, width, height);
		
		if(desimals != 0) {
			value = parseFloat(value).toFixed(desimals)+"";
			value = value.replace(".", ",");
		} else {
			value = Math.round(value);
		}
		
		var scale = width/360;
		var fontScale = scale;
		
		context.textBaseline = "top";
		context.textAlign = "center";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
		else context.fillStyle = color_yellow;
		// context.fillText(title, 180*scale, 5*scale);
		var avg = "";
		if(title.indexOf(" avg") > 0) {
			title = title.replace(" avg", "");
			avg = "AVG";
		}
		context.fillText(title, 180*scale, 5*scale);
		var w = context.measureText(title+" ").width;
		context.font = "bold "+(parseInt(8*fontScale))+"pt Sans-serif";
		context.fillText(avg, w/1.6+180*scale, 14*scale);
		
		context.font = "bold "+(parseInt(60*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		if(value == "1 s") context.fillText("Real time", 180*scale, 138*scale);
		else context.fillText(value, 180*scale, 138*scale);
		
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText(prefix, 180*scale, 227*scale);
		
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText(limit, 75*scale, 170*scale);
		context.fillText(max2, 180*scale, 70*scale);
	}
}

function showClock(name, title, value, desimals) {
	
	var max = 60;
	// document.getElementById(name).width = document.getElementById(name).width;
	var context = document.getElementById(name).getContext("2d");
	context.clearRect(0,0,document.getElementById(name).width,document.getElementById(name).height);
	
	var width = document.getElementById(name).width;
	var height = document.getElementById(name).height;
	
	if(value+"" == "NaN") value = 0;
	
	var thousands = parseInt(value*100)%100;
	var sec = parseInt(value)%60;
	var min = parseInt(value/60%60);
	var hour = parseInt(value/60/60);
	
	if(thousands < 10) thousands = "0"+thousands;
	if(sec < 10) sec = "0"+sec;
	if(min < 10) min = "0"+min;
	
	var txt = "";
	var txt2 = "";
	if(desimals == 0) { // hours
		txt = hour+":"+min+":"+sec;
	} else if(desimals == 1) { // secs
		txt = min+":"+sec;
	} else { // thousands
		txt = min+":"+sec+"."+thousands;
	}
	if(hour > 1) txt2 = hour+" hours";
	else if(hour > 0) txt2 = hour+" hour";
	
	if(height < width) {
		
		context.fillStyle = color_background;
		context.fillRect(0, 0, width, height);
		
		var scale = width/360;
		var fontScale = 0.55;
		
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(32*fontScale))+"pt Sans-serif";
		context.fillStyle = color_line;
		/* context.beginPath();
		context.moveTo(width-42, height-8);
		context.lineTo(width-27, height-23);
		context.lineTo(width-27, height-8);
		context.closePath();
		context.fill(); */
		// context.fillRect(0, height-8, width-40, 1);
		context.fillStyle = color_title;
		context.fillText(title, 40, 0);
		
		context.textAlign = "left";
		context.font = "bold "+(parseInt(60*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		context.fillText(txt, 40, 30);
	} else {
		
		context.fillStyle = color_passive;
		context.fillRect(0, 0, width, height);
		
		value = value%max;
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(0, 0, width, height);
		} else if(value > 0) {
			var angle = value/max-90/360;
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(width/2, 0);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			if(cos > width/2) {
				context.lineTo(width, sin);
				context.lineTo(width, 0);
			} else if(sin > width/2) {
				context.lineTo(cos, height);
				context.lineTo(width, height);
				context.lineTo(width, sin);
				context.lineTo(width, 0);
			} else {
				context.lineTo(0, sin);
				context.lineTo(0, height);
				context.lineTo(width, height);
				context.lineTo(width, sin);
				context.lineTo(width, 0);
			}
			
			context.closePath();
			context.fill();
		}
		
		var bg = document.getElementById("meter-img"+color_meter+"1");
		context.drawImage(bg, 0, 0, width, height);
		
		var scale = width/360;
		var fontScale = scale;
		
		context.textBaseline = "top";
		context.textAlign = "center";
		context.font = "bold "+(parseInt(16*fontScale))+"pt Sans-serif";
		context.fillStyle = color_title;
		context.fillText(title, 180*scale, 110*scale);
		
		context.font = "bold "+(parseInt(60*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		context.fillText(txt, 180*scale, 138*scale);
		
		context.font = "bold "+(parseInt(16*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		context.fillText(txt2, 180*scale, 227*scale);
	}
}

function showDistance(name, title, prefix, value, desimals) {
	
	var max = 1000;
	// document.getElementById(name).width = document.getElementById(name).width;
	var context = document.getElementById(name).getContext("2d");
	context.clearRect(0,0,document.getElementById(name).width,document.getElementById(name).height);
	
	var width = document.getElementById(name).width;
	var height = document.getElementById(name).height;
	
	if(value+"" == "NaN") value = 0;
	
	var txt = value;
	
	if(height < width && height == 240) {
		
		context.fillStyle = color_background;
		context.fillRect(0, 0, width, height);
		
		var bg = document.getElementById("meter220-bg");
		context.drawImage(bg, 0, 0, width, height);
		
		value = txt;
		if(desimals != 0) {
			value = parseFloat(value).toFixed(desimals)+"";
			value = value.replace(".", ",");
		} else {
			value = parseInt(value);
		}
		
		var scale = width/360;
		var fontScale = 0.55;
		
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(32*fontScale))+"pt Sans-serif";
		context.fillStyle = color_line;
		context.beginPath();
		context.moveTo(width-42, height-8);
		context.lineTo(width-27, height-23);
		context.lineTo(width-27, height-8);
		context.closePath();
		context.fill();
		// context.fillRect(0, 2, width-40, 1);
		if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
		else context.fillStyle = color_yellow;
			// context.fillText(title, 0, 0);
			var avg = "";
			if(title.indexOf(" avg") > 0) {
				title = title.replace(" avg", "");
				avg = "AVG";
			}
			context.fillText(title, 40, 10);
			var w = context.measureText(title+" ").width;
			context.font = "bold "+(parseInt(24*fontScale))+"pt Sans-serif";
			context.fillText(avg, w+40, 24);
		
		context.textAlign = "center";
		context.font = "bold "+(parseInt(120*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		if(value == 0 || value == "0,0") context.fillText("-", 170, 60);
		else context.fillText(value, 170, 60);
		
		context.font = "bold "+(parseInt(40*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText(prefix, 170, 180);
	} else if(height < width) {
		
		context.fillStyle = color_background;
		context.fillRect(0, 0, width, height);
		
		value = txt;
		if(desimals != 0) {
			value = parseFloat(value).toFixed(desimals)+"";
			value = value.replace(".", ",");
		} else {
			value = parseInt(value);
		}
		
		var scale = width/360;
		var fontScale = 0.55;
		
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(32*fontScale))+"pt Sans-serif";
		context.fillStyle = color_line;
		context.beginPath();
		context.moveTo(width-42, height-8);
		context.lineTo(width-27, height-23);
		context.lineTo(width-27, height-8);
		context.closePath();
		context.fill();
		// context.fillRect(0, 2, width-40, 1);
		if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
		else context.fillStyle = color_yellow;
			// context.fillText(title, 0, 0);
			var avg = "";
			if(title.indexOf(" avg") > 0) {
				title = title.replace(" avg", "");
				avg = "AVG";
			}
			context.fillText(title, 40, 0);
			var w = context.measureText(title+" ").width;
			context.font = "bold "+(parseInt(24*fontScale))+"pt Sans-serif";
			context.fillText(avg, w+40, 14);
		
		context.textAlign = "left";
		context.font = "bold "+(parseInt(60*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		if(prefix != "") {
			// context.fillText(value+" "+prefix, 0, 30);
			context.fillText(value, 40, 30);
			var w = context.measureText(value+" ").width;
			context.fillStyle = color_label;
			context.font = "bold "+(parseInt(36*fontScale))+"pt Sans-serif";
			context.fillText(prefix, w+40, 30+30*fontScale);
		} else {
			context.fillText(value, 40, 30);
		}
	} else {
		
		context.fillStyle = color_passive;
		context.fillRect(0, 0, width, height);
		
		value = value%max;
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(0, 0, width, height);
		} else if(value > 0) {
			var angle = value/max-90/360;
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(width/2, 0);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			if(cos > width/2) {
				context.lineTo(width, sin);
				context.lineTo(width, 0);
			} else if(sin > width/2) {
				context.lineTo(cos, height);
				context.lineTo(width, height);
				context.lineTo(width, sin);
				context.lineTo(width, 0);
			} else {
				context.lineTo(0, sin);
				context.lineTo(0, height);
				context.lineTo(width, height);
				context.lineTo(width, sin);
				context.lineTo(width, 0);
			}
			
			context.closePath();
			context.fill();
		}
		
		var bg = document.getElementById("meter-img"+color_meter+"1");
		context.drawImage(bg, 0, 0, width, height);
		
		value = txt;
		if(desimals != 0) {
			value = parseFloat(value).toFixed(desimals)+"";
			value = value.replace(".", ",");
		} else {
			value = parseInt(value);
		}
		
		var scale = width/360;
		var fontScale = scale;
		
		context.textBaseline = "top";
		context.textAlign = "center";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
		else context.fillStyle = color_yellow;
		context.fillText(title, 180*scale, 5*scale);
		
		context.font = "bold "+(parseInt(60*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		context.fillText(value, 180*scale, 138*scale);
		
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText(prefix, 180*scale, 227*scale);
	}
}

function showDistribution(name, title, prefix, value1, value2, value3, value4, min, max, desimals) {
	
	// document.getElementById(name).width = document.getElementById(name).width;
	var context = document.getElementById(name).getContext("2d");
	context.clearRect(0,0,document.getElementById(name).width,document.getElementById(name).height);
	
	var width = document.getElementById(name).width;
	var height = document.getElementById(name).height;
	
	if(value1+"" == "NaN") value1 = 0;
	if(value2+"" == "NaN") value2 = 0;
	if(value3+"" == "NaN") value3 = 0;
	if(value4+"" == "NaN") value4 = 0;
	
	if(height < width && height == 240) {
		
		context.fillStyle = color_background;
		context.fillRect(0, 0, width, height);
		
		var bg = document.getElementById("meter220-bg");
		context.drawImage(bg, 0, 0, width, height);
		
		if(desimals != 0) {
			value1 = parseFloat(value1).toFixed(desimals)+"";
			value1 = value1.replace(".", ",");
			value2 = parseFloat(value2).toFixed(desimals)+"";
			value2 = value2.replace(".", ",");
			value3 = parseFloat(value3).toFixed(desimals)+"";
			value3 = value3.replace(".", ",");
			value4 = parseFloat(value4).toFixed(desimals)+"";
			value4 = value4.replace(".", ",");
		} else {
			value1 = Math.round(value1);
			value2 = Math.round(value2);
			value3 = Math.round(value3);
			value4 = Math.round(value4);
			
			if(value1 < min) value1 = 0;
			if(value2 < min) value2 = 0;
			if(value3 < min) value3 = 0;
			if(value4 < min) value4 = 0;
			
			if(value1 > max) value1 = 0;
			if(value2 > max) value2 = 0;
			if(value3 > max) value3 = 0;
			if(value4 > max) value4 = 0;
		}
		
		var scale = width/360;
		var fontScale = 0.55;
		
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(32*fontScale))+"pt Sans-serif";
		context.fillStyle = color_line;
		context.beginPath();
		context.moveTo(width-42, height-8);
		context.lineTo(width-27, height-23);
		context.lineTo(width-27, height-8);
		context.closePath();
		context.fill();
		// context.fillRect(0, 2, width-40, 1);
		if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
		else context.fillStyle = color_yellow;
			// context.fillText(title, 0, 0);
			var avg = "";
			if(title.indexOf(" avg") > 0) {
				title = title.replace(" avg", "");
				avg = "AVG";
			}
			context.fillText(title, 40, 10);
			var w = context.measureText(title+" ").width;
			context.font = "bold "+(parseInt(24*fontScale))+"pt Sans-serif";
			context.fillText(avg, w+40, 24);
		
		context.textAlign = "center";
		context.font = "bold "+(parseInt(76*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		// context.fillText(value1+" / "+value4+" / "+value2+" / "+value3, 130, 50);
		if(value1 == 0 && value2 == 0 && value3 == 0 && value4 == 0) {
			context.font = "bold "+(parseInt(120*fontScale))+"pt Sans-serif";
			context.fillText("-", 170, 60);
		} else {
			context.fillText(value1+" / "+value4, 170, 60);
			context.fillText(value2+" / "+value3, 170, 120);
		}
		
		context.font = "bold "+(parseInt(40*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText(prefix, 170, 180);
	} else if(height < width) {
		
		context.fillStyle = color_background;
		context.fillRect(0, 0, width, height);
		
		if(desimals != 0) {
			value1 = parseFloat(value1).toFixed(desimals)+"";
			value1 = value1.replace(".", ",");
			value2 = parseFloat(value2).toFixed(desimals)+"";
			value2 = value2.replace(".", ",");
			value3 = parseFloat(value3).toFixed(desimals)+"";
			value3 = value3.replace(".", ",");
			value4 = parseFloat(value4).toFixed(desimals)+"";
			value4 = value4.replace(".", ",");
		} else {
			value1 = Math.round(value1);
			value2 = Math.round(value2);
			value3 = Math.round(value3);
			value4 = Math.round(value4);
			
			if(value1 < min) value1 = 0;
			if(value2 < min) value2 = 0;
			if(value3 < min) value3 = 0;
			if(value4 < min) value4 = 0;
			
			if(value1 > max) value1 = 0;
			if(value2 > max) value2 = 0;
			if(value3 > max) value3 = 0;
			if(value4 > max) value4 = 0;
		}
		
		var scale = width/360;
		var fontScale = 0.55;
		
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(32*fontScale))+"pt Sans-serif";
		context.fillStyle = color_line;
		context.beginPath();
		context.moveTo(width-42, height-8);
		context.lineTo(width-27, height-23);
		context.lineTo(width-27, height-8);
		context.closePath();
		context.fill();
		// context.fillRect(0, 2, width-40, 1);
		if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
		else context.fillStyle = color_yellow;
			// context.fillText(title, 0, 0);
			var avg = "";
			if(title.indexOf(" avg") > 0) {
				title = title.replace(" avg", "");
				avg = "AVG";
			}
			context.fillText(title, 40, 0);
			var w = context.measureText(title+" ").width;
			context.font = "bold "+(parseInt(24*fontScale))+"pt Sans-serif";
			context.fillText(avg, w+40, 14);
		
		context.textAlign = "left";
		context.font = "bold "+(parseInt(46*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		if(prefix != "") {
			// context.fillText(+value1+" / "+value4+" / "+value2+" / "+value3+" "+prefix, 0, 40);
			context.fillText(value1+" / "+value4+" / "+value2+" / "+value3, 40, 40);
			var w = context.measureText(value1+" / "+value4+" / "+value2+" / "+value3+" ").width;
			context.fillStyle = color_label;
			context.font = "bold "+(parseInt(36*fontScale))+"pt Sans-serif";
			context.fillText(prefix, w+40, 30+30*fontScale);
		} else {
			context.fillText(value1+" / "+value4+" / "+value2+" / "+value3, 40, 40);
		}
	} else {
		
		context.fillStyle = color_passive;
		context.fillRect(0, 0, width, height);
		
		var value = value1;
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(0, 0, width/2, height/2);
		} else if(value < min) {
		} else {
			var angle = value/(max*4)+180/360;
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(0, height/2);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			context.lineTo(0, sin);
			
			context.closePath();
			context.fill();
		}
		
		value = value2;
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(0, height/2, width/2, height);
		} else if(value < min) {
		} else {
			var angle = 180/360-value/(max*4);
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(0, height/2);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			context.lineTo(0, sin);
			
			context.closePath();
			context.fill();
		}
		
		value = value3;
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(width/2, height/2, width, height);
		} else if(value < min) {
		} else {
			var angle = value/(max*4);
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(width, height/2);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			context.lineTo(width, sin);
			
			context.closePath();
			context.fill();
		}
		
		value = value4;
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(width/2, 0, width, height/2);
		} else if(value < min) {
		} else {
			var angle = 0-value/(max*4);
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(width, height/2);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			context.lineTo(width, sin);
			
			context.closePath();
			context.fill();
		}
		
		var bg = document.getElementById("meter-img"+color_meter+"2");
		context.drawImage(bg, 0, 0, width, height);
		
		if(desimals != 0) {
			value1 = parseFloat(value1).toFixed(desimals)+"";
			value1 = value1.replace(".", ",");
			value2 = parseFloat(value2).toFixed(desimals)+"";
			value2 = value2.replace(".", ",");
			value3 = parseFloat(value3).toFixed(desimals)+"";
			value3 = value3.replace(".", ",");
			value4 = parseFloat(value4).toFixed(desimals)+"";
			value4 = value4.replace(".", ",");
		} else {
			value1 = Math.round(value1);
			value2 = Math.round(value2);
			value3 = Math.round(value3);
			value4 = Math.round(value4);
			
			if(value1 < min) value1 = 0;
			if(value2 < min) value2 = 0;
			if(value3 < min) value3 = 0;
			if(value4 < min) value4 = 0;
			
			if(value1 > max) value1 = 0;
			if(value2 > max) value2 = 0;
			if(value3 > max) value3 = 0;
			if(value4 > max) value4 = 0;
		}
		
		var scale = width/360;
		var fontScale = scale;
		
		context.textBaseline = "top";
		context.textAlign = "center";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
		else context.fillStyle = color_yellow;
		// context.fillText(title, 180*scale, 5*scale);
		var avg = "";
		if(title.indexOf(" avg") > 0) {
			title = title.replace(" avg", "");
			avg = "AVG";
		}
		context.fillText(title, 180*scale, 5*scale);
		var w = context.measureText(title+" ").width;
		context.font = "bold "+(parseInt(8*fontScale))+"pt Sans-serif";
		context.fillText(avg, w/1.6+180*scale, 14*scale);
		
		context.font = "bold "+(parseInt(42*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		context.fillText(value1, 130*scale, 108*scale);
		context.fillText(value2, 130*scale, 193*scale);
		context.fillText(value3, 230*scale, 193*scale);
		context.fillText(value4, 230*scale, 108*scale);
		
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText(prefix, 180*scale, 172*scale);
		context.fillText("Quads", 180*scale, 72*scale);
		context.fillText("Hams", 180*scale, 272*scale);
		context.fillText("Left", 80*scale, 172*scale);
		context.fillText("Right", 270*scale, 172*scale);
	}
}

function showBalance(name, title, title1, title2, value, value1, value2, value3, value4, min, max, desimals) {
	
	// document.getElementById(name).width = document.getElementById(name).width;
	var context = document.getElementById(name).getContext("2d");
	context.clearRect(0,0,document.getElementById(name).width,document.getElementById(name).height);
	
	var width = document.getElementById(name).width;
	var height = document.getElementById(name).height;
	// value = 56.7;
	
	if(value1+"" == "NaN") value1 = 0;
	if(value2+"" == "NaN") value2 = 0;
	if(value3+"" == "NaN") value3 = 0;
	if(value4+"" == "NaN") value4 = 0;
	
	if(value+""== "NaN") value = 0;
	
	if(height < width && height == 240) {
		
		context.fillStyle = color_background;
		context.fillRect(0, 0, width, height);
		
		var bg = document.getElementById("meter220-bg");
		context.drawImage(bg, 0, 0, width, height);
		
		var v2 = value2;
		var value2 = 100-value;
		if(value1 == 0 && v2 == 0) value2 = 0;
		
		if(desimals != 0) {
			value = parseFloat(value).toFixed(desimals)+"";
			value = value.replace(".", ",");
			value2 = parseFloat(value2).toFixed(desimals)+"";
			value2 = value2.replace(".", ",");
		} else if(value != 0) {
			// value = parseInt(value);
			// value2 = parseInt(value2);
			value = Math.round(parseFloat(value));
			value2 = 100-value;
		}
		
		var scale = width/360;
		var fontScale = 0.55;
		
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(32*fontScale))+"pt Sans-serif";
		context.fillStyle = color_line;
		context.beginPath();
		context.moveTo(width-42, height-8);
		context.lineTo(width-27, height-23);
		context.lineTo(width-27, height-8);
		context.closePath();
		context.fill();
		// context.fillRect(0, 2, width-40, 1);
		if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
		else context.fillStyle = color_yellow;
			// context.fillText(title, 0, 0);
			var avg = "";
			if(title.indexOf(" avg") > 0) {
				title = title.replace(" avg", "");
				avg = "AVG";
			}
			context.fillText(title, 40, 10);
			var w = context.measureText(title+" ").width;
			context.font = "bold "+(parseInt(24*fontScale))+"pt Sans-serif";
			context.fillText(avg, w+40, 24);
		
		/* context.textAlign = "center";
		context.font = "bold "+(parseInt(96*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		context.fillText(value+" / "+value2, 170, 70); */
		
		context.textAlign = "right";
		context.font = "bold "+(parseInt(96*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		if(value == 0 && value2 == 0) {
			context.font = "bold "+(parseInt(120*fontScale))+"pt Sans-serif";
			context.fillText("-", 170, 60);
		} else {
			context.fillText(value, 150, 70);
			context.textAlign = "left";
			context.fillText(value2, 190, 70);
			
			context.beginPath();
			context.moveTo(167, 70);
			context.lineTo(172, 70);
			context.lineTo(172, 150);
			context.lineTo(167, 150);
			context.closePath();
			context.fill();
		}
		
		context.textAlign = "center";
		context.font = "bold "+(parseInt(40*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText("%", 170, 180);
	} else if(height < width) {
		
		context.fillStyle = color_background;
		context.fillRect(0, 0, width, height);
		
		var v2 = value2;
		var value2 = 100-value;
		if(value1 == 0 && v2 == 0) value2 = 0;
		
		if(desimals != 0) {
			value = parseFloat(value).toFixed(desimals)+"";
			value = value.replace(".", ",");
			value2 = parseFloat(value2).toFixed(desimals)+"";
			value2 = value2.replace(".", ",");
		} else if(value != 0) {
			// value = parseInt(value);
			// value2 = parseInt(value2);
			value = Math.round(parseFloat(value));
			value2 = 100-value;
		}
		
		var scale = width/360;
		var fontScale = 0.55;
		
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(32*fontScale))+"pt Sans-serif";
		context.fillStyle = color_line;
		context.beginPath();
		context.moveTo(width-42, height-8);
		context.lineTo(width-27, height-23);
		context.lineTo(width-27, height-8);
		context.closePath();
		context.fill();
		// context.fillRect(0, 2, width-40, 1);
		if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
		else context.fillStyle = color_yellow;
			// context.fillText(title, 0, 0);
			var avg = "";
			if(title.indexOf(" avg") > 0) {
				title = title.replace(" avg", "");
				avg = "AVG";
			}
			context.fillText(title, 40, 0);
			var w = context.measureText(title+" ").width;
			context.font = "bold "+(parseInt(24*fontScale))+"pt Sans-serif";
			context.fillText(avg, w+40, 14);
		
		context.textAlign = "left";
		context.font = "bold "+(parseInt(54*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		// context.fillText(value+" / "+value2+" %", 40, 30);
			context.fillText(value+" / "+value2, 40, 36);
			var w = context.measureText(value+" / "+value2+" ").width;
			context.fillStyle = color_label;
			context.font = "bold "+(parseInt(36*fontScale))+"pt Sans-serif";
			context.fillText("%", w+40, 30+30*fontScale);
	} else {
		
		context.fillStyle = color_passive;
		context.fillRect(0, 0, width, height);
		
		min = 0;
		max = 100;
		
		var tmp = value;
		var value = value1;
		value = tmp;
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(0, 0, width/2, height/2);
		} else if(value < min) {
		} else {
			var angle = value/(max*4)+180/360;
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(0, height/2);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			context.lineTo(0, sin);
			
			context.closePath();
			context.fill();
		}
		
		value = value2;
		value = tmp;
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(0, height/2, width/2, height);
		} else if(value < min) {
		} else {
			var angle = 180/360-value/(max*4);
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(0, height/2);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			context.lineTo(0, sin);
			
			context.closePath();
			context.fill();
		}
		
		value = value3;
		value = 100-tmp;
		if(value2 == 0) value = 0;
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(width/2, height/2, width, height);
		} else if(value < min) {
		} else {
			var angle = value/(max*4);
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(width, height/2);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			context.lineTo(width, sin);
			
			context.closePath();
			context.fill();
		}
		
		value = value4;
		value = 100-tmp;
		if(value2 == 0) value = 0;
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(width/2, 0, width, height/2);
		} else if(value < min) {
		} else {
			var angle = 0-value/(max*4);
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(width, height/2);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			context.lineTo(width, sin);
			
			context.closePath();
			context.fill();
		}
		
		var bg = document.getElementById("meter-img"+color_meter+"3");
		context.drawImage(bg, 0, 0, width, height);
		
		var value = parseInt(value1)+parseInt(value2)+parseInt(value3)+parseInt(value4);
		
		if(desimals != 0) {
			value = parseFloat(value).toFixed(desimals)+"";
			value = value.replace(".", ",");
		} else {
			value = parseInt(value);
		}
		
		value = tmp;
		var value5 = 100-value;
		if(value2 == 0) value5 = 0;
		
		if(desimals != 0) {
			value = parseFloat(value).toFixed(desimals)+"";
			value = value.replace(".", ",");
			value5 = parseFloat(value5).toFixed(desimals)+"";
			value5 = value5.replace(".", ",");
		} else if( value != 0 ) {
			// value = parseInt(value);
			// value5 = parseInt(value5);
			value = Math.round(parseFloat(value));
			value5 = 100-value;
		}
		
		var scale = width/360;
		var fontScale = scale;
		
		context.textBaseline = "top";
		context.textAlign = "center";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
		else context.fillStyle = color_yellow;
		// context.fillText(title, 180*scale, 5*scale);
		var avg = "";
		if(title.indexOf(" avg") > 0) {
			title = title.replace(" avg", "");
			avg = "AVG";
		}
		context.fillText(title, 180*scale, 5*scale);
		var w = context.measureText(title+" ").width;
		context.font = "bold "+(parseInt(8*fontScale))+"pt Sans-serif";
		context.fillText(avg, w/1.6+180*scale, 14*scale);
		
		context.textBaseline = "bottom";
		context.font = "bold "+(parseInt(48*fontScale))+"pt Sans-serif";
		context.textAlign = "center";
		context.fillStyle = color_value;
		context.fillText(value, 130*scale, 225*scale);
		
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.textAlign = "center";
		context.fillStyle = color_label;
		context.fillText(title1, 130*scale, 150*scale);
		
		context.font = "bold "+(parseInt(48*fontScale))+"pt Sans-serif";
		context.textAlign = "center";
		context.fillStyle = color_value;
		context.fillText(value5, 230*scale, 225*scale);
		
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.textAlign = "center";
		context.fillStyle = color_label;
		context.fillText(title2, 230*scale, 150*scale);
		
		context.textBaseline = "top";
		context.textAlign = "center";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillText("%", 180*scale, 172*scale);
				
		/* var total = parseInt(value1)+parseInt(value2)+parseInt(value3)+parseInt(value4);
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText("Left Quadriceps", 0, 10*scale);
		context.font = "bold "+(parseInt(16*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		value = parseFloat(value1/total*100);
		if(value+""== "NaN") value = 0;
		context.fillText((value.toFixed(1)+"").replace(".", ",")+" %", 0, 30*scale);
		
		context.textAlign = "right";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText("Right Quadriceps", width, 10*scale);
		context.font = "bold "+(parseInt(16*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		value = parseFloat(value4/total*100);
		if(value+""== "NaN") value = 0;
		context.fillText((value.toFixed(1)+"").replace(".", ",")+" %", width, 30*scale);
		
		context.textBaseline = "bottom";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText("Left Hamstrings", 0, height-10*scale);
		context.font = "bold "+(parseInt(16*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		value = parseFloat(value2/total*100);
		if(value+""== "NaN") value = 0;
		context.fillText((value.toFixed(1)+"").replace(".", ",")+" %", 0, height-30*scale);
		
		context.textAlign = "right";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText("Right Hamstrings", width, height-10*scale);
		context.font = "bold "+(parseInt(16*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		value = parseFloat(value3/total*100);
		if(value+""== "NaN") value = 0;
		context.fillText((value.toFixed(1)+"").replace(".", ",")+" %", width, height-30*scale); */
		
		/* context.strokeStyle = "#a0a0a0";
		context.lineWidth = 1;
		context.beginPath();
		context.moveTo(0, 11);
		context.lineTo(width, 11);
		context.stroke();
		context.beginPath();
		context.moveTo(0, height-10);
		context.lineTo(width, height-10);
		context.stroke(); */
	}
}

function showRatio(name, title, title1, title2, value, value1, value2, value3, value4, min, max, desimals) {
	
	// document.getElementById(name).width = document.getElementById(name).width;
	var context = document.getElementById(name).getContext("2d");
	context.clearRect(0,0,document.getElementById(name).width,document.getElementById(name).height);
	
	var width = document.getElementById(name).width;
	var height = document.getElementById(name).height;
	// value = 56.7;
	
	if(value1+"" == "NaN") value1 = 0;
	if(value2+"" == "NaN") value2 = 0;
	if(value3+"" == "NaN") value3 = 0;
	if(value4+"" == "NaN") value4 = 0;
	
	if(value+""== "NaN") value = 0;
	
	if(height < width && height == 240) {
		
		context.fillStyle = color_background;
		context.fillRect(0, 0, width, height);
		
		var bg = document.getElementById("meter220-bg");
		context.drawImage(bg, 0, 0, width, height);
		
		var v2 = value4;
		var value2 = 100-value;
		if(value1 == 0 && v2 == 0) value2 = 0;
		
		if(desimals != 0) {
			value = parseFloat(value).toFixed(desimals)+"";
			value = value.replace(".", ",");
			value2 = parseFloat(value2).toFixed(desimals)+"";
			value2 = value2.replace(".", ",");
		} else if( value != 0 ) {
			// value = parseInt(value);
			// value2 = parseInt(value2);
			value = Math.round(parseFloat(value));
			value2 = 100-value;
		}
		
		var scale = width/360;
		var fontScale = 0.55;
		
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(32*fontScale))+"pt Sans-serif";
		context.fillStyle = color_line;
		context.beginPath();
		context.moveTo(width-42, height-8);
		context.lineTo(width-27, height-23);
		context.lineTo(width-27, height-8);
		context.closePath();
		context.fill();
		// context.fillRect(0, 2, width-40, 1);
		if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
		else context.fillStyle = color_yellow;
			// context.fillText(title, 0, 0);
			var avg = "";
			if(title.indexOf(" avg") > 0) {
				title = title.replace(" avg", "");
				avg = "AVG";
			}
			context.fillText(title, 40, 10);
			var w = context.measureText(title+" ").width;
			context.font = "bold "+(parseInt(24*fontScale))+"pt Sans-serif";
			context.fillText(avg, w+40, 24);
		
		context.textAlign = "center";
		context.font = "bold "+(parseInt(72*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		if(value == 0 && value2 == 0) {
			context.font = "bold "+(parseInt(120*fontScale))+"pt Sans-serif";
			context.fillText("-", 170, 60);
		} else {
			context.fillText(value, 170, 60);
			context.fillText(value2, 170, 120);
			
			context.beginPath();
			context.moveTo(120, 117);
			context.lineTo(220, 117);
			context.lineTo(220, 122);
			context.lineTo(120, 122);
			context.closePath();
			context.fill();
		}
		
		context.font = "bold "+(parseInt(40*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText("%", 170, 180);
	} else if(height < width) {
		
		context.fillStyle = color_background;
		context.fillRect(0, 0, width, height);
		
		var v2 = value4;
		var value2 = 100-value;
		if(value1 == 0 && v2 == 0) value2 = 0;
		
		if(desimals != 0) {
			value = parseFloat(value).toFixed(desimals)+"";
			value = value.replace(".", ",");
			value2 = parseFloat(value2).toFixed(desimals)+"";
			value2 = value2.replace(".", ",");
		} else if( value != 0 ) {
			// value = parseInt(value);
			// value2 = parseInt(value2);
			value = Math.round(parseFloat(value));
			value2 = 100-value;
		}
		
		var scale = width/360;
		var fontScale = 0.55;
		
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(32*fontScale))+"pt Sans-serif";
		context.fillStyle = color_line;
		context.beginPath();
		context.moveTo(width-42, height-8);
		context.lineTo(width-27, height-23);
		context.lineTo(width-27, height-8);
		context.closePath();
		context.fill();
		// context.fillRect(0, 2, width-40, 1);
		if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
		else context.fillStyle = color_yellow;
			// context.fillText(title, 0, 0);
			var avg = "";
			if(title.indexOf(" avg") > 0) {
				title = title.replace(" avg", "");
				avg = "AVG";
			}
			context.fillText(title, 40, 0);
			var w = context.measureText(title+" ").width;
			context.font = "bold "+(parseInt(24*fontScale))+"pt Sans-serif";
			context.fillText(avg, w+40, 14);
		
		context.textAlign = "left";
		context.font = "bold "+(parseInt(54*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		// context.fillText(value+" / "+value2+" %", 40, 30);
			context.fillText(value+" / "+value2, 40, 36);
			var w = context.measureText(value+" / "+value2+" ").width;
			context.fillStyle = color_label;
			context.font = "bold "+(parseInt(36*fontScale))+"pt Sans-serif";
			context.fillText("%", w+40, 30+30*fontScale);
	} else {
		
		context.fillStyle = color_passive;
		context.fillRect(0, 0, width, height);
		
		min = 0;
		max = 100;
		var tmp = value;
		var value = value1;
		value = tmp;
		
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(0, 0, width/2, height/2);
		} else if(value < min) {
		} else {
			var angle = (100-value)/(max*4)+180/360;
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(width/2, 0);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			context.lineTo(cos, 0);
			
			context.closePath();
			context.fill();
		}
		
		value = value2;
		value = 100-tmp;
		if(value4 == 0) value = 0;
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(0, height/2, width/2, height);
		} else if(value < min) {
		} else {
			var angle = 180/360-(100-value)/(max*4);
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(width/2, height);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			context.lineTo(cos, height);
			
			context.closePath();
			context.fill();
		}
		
		value = value3;
		value = 100-tmp;
		if(value4 == 0) value = 0;
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(width/2, height/2, width, height);
		} else if(value < min) {
		} else {
			var angle = (100-value)/(max*4);
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(width/2, height);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			context.lineTo(cos, height);
			
			context.closePath();
			context.fill();
		}
		
		value = value4;
		value = tmp;
		if( value > max ) {
			context.fillStyle = color_active;
			context.fillRect(width/2, 0, width, height/2);
		} else if(value < min) {
		} else {
			var angle = 0-(100-value)/(max*4);
			var cos = Math.cos(angle*Math.PI*2)*width/2+width/2;
			var sin = Math.sin(angle*Math.PI*2)*width/2+width/2;
			
			context.lineWidth = 1;
			context.fillStyle = color_active;
			context.beginPath();
			context.arc(10,10,10,0,Math.PI*2,true);
			
			context.moveTo(width/2, 0);
			context.lineTo(width/2, height/2);
			context.lineTo(cos, sin);
			context.lineTo(cos, 0);
			
			context.closePath();
			context.fill();
		}
		
		var bg = document.getElementById("meter-img"+color_meter+"4");
		context.drawImage(bg, 0, 0, width, height);
		
		var value = parseInt(value1)+parseInt(value2)+parseInt(value3)+parseInt(value4);
		
		if(desimals != 0) {
			value = parseFloat(value).toFixed(desimals)+"";
			value = value.replace(".", ",");
		} else {
			value = parseInt(value);
		}
		
		value = tmp;
		var value5 = 100-value;
		if(value4 == 0) value5 = 0;
		
		if(desimals != 0) {
			value = parseFloat(value).toFixed(desimals)+"";
			value = value.replace(".", ",");
			value5 = parseFloat(value5).toFixed(desimals)+"";
			value5 = value5.replace(".", ",");
		} else if( value != 0 ) {
			// value = parseInt(value);
			// value5 = parseInt(value5);
			value = Math.round(parseFloat(value));
			value5 = 100-value;
		}
		
		var scale = width/360;
		var fontScale = scale;
		
		context.textBaseline = "top";
		context.textAlign = "center";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		if(name == "meter02" || name == "meter12") context.fillStyle = color_title;
		else context.fillStyle = color_yellow;
		// context.fillText(title, 180*scale, 5*scale);
		var avg = "";
		if(title.indexOf(" avg") > 0) {
			title = title.replace(" avg", "");
			avg = "AVG";
		}
		context.fillText(title, 180*scale, 5*scale);
		var w = context.measureText(title+" ").width;
		context.font = "bold "+(parseInt(8*fontScale))+"pt Sans-serif";
		context.fillText(avg, w/1.6+180*scale, 14*scale);
		
		context.textBaseline = "bottom";
		context.font = "bold "+(parseInt(48*fontScale))+"pt Sans-serif";
		// context.textAlign = "left";
		context.fillStyle = color_value;
		context.fillText(value, 180*scale, 165*scale);
		
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		// context.textAlign = "left";
		context.fillStyle = color_label;
		context.fillText(title1, 180*scale, 90*scale);
		
		context.font = "bold "+(parseInt(48*fontScale))+"pt Sans-serif";
		// context.textAlign = "left";
		context.fillStyle = color_value;
		context.fillText(value5, 180*scale, 270*scale);
		
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		// context.textAlign = "left";
		context.fillStyle = color_label;
		context.fillText(title2, 180*scale, 290*scale);
		
		context.textBaseline = "top";
		context.textAlign = "center";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillText("%", 180*scale, 172*scale);
		
		/* var total = parseInt(value1)+parseInt(value2)+parseInt(value3)+parseInt(value4);
		context.textBaseline = "top";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText("Left Quadriceps", 0, 10*scale);
		context.font = "bold "+(parseInt(16*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		value = parseFloat(value1/total*100);
		if(value+""== "NaN") value = 0;
		context.fillText((value.toFixed(1)+"").replace(".", ",")+" %", 0, 30*scale);
		
		context.textAlign = "right";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText("Right Quadriceps", width, 10*scale);
		context.font = "bold "+(parseInt(16*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		value = parseFloat(value4/total*100);
		if(value+""== "NaN") value = 0;
		context.fillText((value.toFixed(1)+"").replace(".", ",")+" %", width, 30*scale);
		
		context.textBaseline = "bottom";
		context.textAlign = "left";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText("Left Hamstrings", 0, height-10*scale);
		context.font = "bold "+(parseInt(16*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		value = parseFloat(value2/total*100);
		if(value+""== "NaN") value = 0;
		context.fillText((value.toFixed(1)+"").replace(".", ",")+" %", 0, height-30*scale);
		
		context.textAlign = "right";
		context.font = "bold "+(parseInt(12*fontScale))+"pt Sans-serif";
		context.fillStyle = color_label;
		context.fillText("Right Hamstrings", width, height-10*scale);
		context.font = "bold "+(parseInt(16*fontScale))+"pt Sans-serif";
		context.fillStyle = color_value;
		value = parseFloat(value3/total*100);
		if(value+""== "NaN") value = 0;
		context.fillText((value.toFixed(1)+"").replace(".", ",")+" %", width, height-30*scale); */
		
		/* context.strokeStyle = "#a0a0a0";
		context.lineWidth = 1;
		context.beginPath();
		context.moveTo(0, 11);
		context.lineTo(width, 11);
		context.stroke();
		context.beginPath();
		context.moveTo(0, height-10);
		context.lineTo(width, height-10);
		context.stroke(); */
	}
}

function showGraph(name, title, prefix, arr, min, max, dataWidth, dataHeight, touchLeft) {
	
	var context = document.getElementById(name).getContext("2d");
	context.clearRect(0,0,document.getElementById(name).width,document.getElementById(name).height);
	
	var width = document.getElementById(name).width;
	var height = document.getElementById(name).height;
	
	context.fillStyle = "#000000";
	context.fillRect(0, 30, width, height);
	
	context.fillStyle = "#444444";
	context.clearRect(graphPaddingLeft, graphPaddingTop, dataWidth, dataHeight);
	
	context.fillStyle = "#111111";
	context.fillRect(graphPaddingLeft, graphPaddingTop, dataWidth, dataHeight);
	
	var start = 0;
	
	var step = mDataCount/dataWidth;
	if(step < 1) step = 1;
	var arr = new Array();
	// var mmax = 0;
	for(var j = 0; j < mDataCount; j++) {
		arr[parseInt(j/step)] = 0;
	}
	for(var i = 0; i < mChannelCount; i++) {
		for(var j = 0; j < mDataCount; j++) {
			arr[parseInt(j/step)] += (parseInt(mData[i][j])*1.0/step);
			// if(arr[parseInt(j/step)] > mmax) mmax = parseInt(arr[parseInt(j/step)]);
		}
	}
	var arr2 = new Array(); // smooth / 29.5.2014 / jariha
	for(var i = 0; i < arr.length; i++) {
		/* if(i > 2) arr2[arr2.length] = (arr[i]+arr[i-1]+arr[i-2])/3;
		else if(i == 1) arr2[arr2.length] = (arr[i]+arr[i-1])/2;
		else arr2[arr2.length] = arr[i]; */
		var tmp = arr[i];
		var t = 1;
		if(i >= smoothTime) {
			for(var j = 1; j < smoothTime; j++) {
				tmp += arr[i-j];
				t++;
			}
		} else {
			for(var j = 1; j <= i; j++) {
				tmp += arr[i-j];
				t++;
			}
		}
		arr2[i] = tmp/t;
	}
	arr = arr2;
	
	/* var val = val1 = val2 = val3 = val4 = val5 = 0;
	for(var i = 0; i < arr.length; i++) {
		val5 = val4;
		val4 = val3;
		val3 = val2;
		val2 = val1;
		val1 = arr[i];
		var val = (val1+val2+val3+val4+val5)/5;
		if(i < 5) val = (val1+val2+val3+val4+val5)/(i+1);
		
		arr[i] = val;
	} */
	
	// if(arr.length > dataWidth) start = arr.length - dataWidth;
	
	var str = "";
	var limit = mHz;
	if(isHistory || mPeriod > 1) limit = (500*((mHz*mPeriod)/mDataCount)); // mPeriod; // 60;
	
	targetStart = parseInt(mGraphLeft);
	targetEnd = parseInt(mGraphRight);
	
	var x = targetEnd; // arr.length-start;
	context.strokeStyle = "#888888";
	context.fillStyle = "#222222";
	context.fillRect(graphPaddingLeft+targetStart, graphPaddingTop, targetEnd-targetStart, dataHeight);
	
    var xScale = 1;
    if(arr.length > 1 && arr.length < 500.0/mHz) xScale = (500.0/mHz)/arr.length;
	context.beginPath();
	for(i = 1; i < arr.length-1; i++) {
		var x = i-start;
		var h = arr[i]*1.0/mlScale/max*dataHeight; // (arr[i]/mlScale-min)/(max-min) * dataHeight;
		if(h < 0) h = 0;
		if(h > dataHeight) h = dataHeight;
		
		context.strokeStyle = "#ffdd00";
		
		if(i == start) context.moveTo(graphPaddingLeft+x*xScale,graphPaddingTop+dataHeight);
		else context.lineTo(graphPaddingLeft+x*xScale,graphPaddingTop+dataHeight-h);
		// context.moveTo(graphPaddingLeft+x,graphPaddingTop+dataHeight);
		// context.lineTo(graphPaddingLeft+x,graphPaddingTop+dataHeight-h);
	}
	context.stroke();
	
	var scale = width/360;
	var fontScale = 1;
	
	context.textBaseline = "top";
	context.textAlign = "center";
	context.font = "bold "+(parseInt(16*fontScale))+"pt Sans-serif";
	context.fillStyle = "#ffdd00";
	context.fillText(title, width/2, 5);
	
	if(gdTarget == 180) {
		context.fillStyle = "#ffffff";
		context.textAlign = "right";
		var offset = 20;
		if(targetEnd-targetStart < 50) offset = 0;
		context.fillText(printTime(parseInt(targetStart/500*mDataCount/mHz)), graphPaddingLeft+targetStart+offset, graphPaddingTop);
		context.textAlign = "left";
		context.fillText(printTime(parseInt(targetEnd/500*mDataCount/mHz)), graphPaddingLeft+targetEnd-offset, graphPaddingTop);
	}
	
	context.textBaseline = "bottom";
	context.textAlign = "left";
	context.font = "bold "+(parseInt(16*fontScale))+"pt Sans-serif";
	context.fillStyle = "#ffdd00";
	// context.fillText("Close", graphPaddingLeft+dataWidth+20, graphPaddingTop+dataHeight);
	
	var zeroLine = graphPaddingTop+dataHeight;
	var arr = mDataHR;
	var yScale = dataHeight/240.0;
	var xScale = 1;
	if(arr.length > 500.0/mHz) xScale = (500.0/mHz)/arr.length;
    if(arr.length > 1) xScale = (500.0/mHz)/arr.length;
	
	context.lineWidth = 3;
	context.strokeStyle = color_alert;
	context.beginPath();
	context.moveTo(graphPaddingLeft,zeroLine-arr[0]*yScale);
	for(var i = 1; i < arr.length; i++) {
		context.lineTo(graphPaddingLeft+i*mHz*xScale,zeroLine-arr[i]*yScale);
	}
	context.stroke();
	
	var arr = new Array();
	for(var i = 0; i < mDataExtra.length; i++) {
		var ar0 = mDataExtra[i];
		var ar1 = ar0.split(",");
		arr[arr.length] = parseInt(ar1[4]);
	}
	var yScale = dataHeight/40.0;
	var xScale = 1;
	if(arr.length > 500.0/mHz) xScale = (500.0/mHz)/arr.length;
    if(arr.length > 1) xScale = (500.0/mHz)/arr.length;
	
	var green = "#67a867";
	context.strokeStyle = green;
	context.beginPath();
	context.moveTo(graphPaddingLeft,zeroLine-arr[0]*yScale);
	for(var i = 1; i < arr.length; i++) {
		context.lineTo(graphPaddingLeft+i*mHz*xScale,zeroLine-arr[i]*yScale);
	}
	context.stroke();
}

function printTime(value) {
	var thousands = parseInt(value*100)%100;
	var sec = parseInt(value)%60;
	var min = parseInt(value/60%60);
	var hour = parseInt(value/60/60);
	
	if(thousands < 10) thousands = "0"+thousands;
	if(sec < 10) sec = "0"+sec;
	if(min < 10) min = "0"+min;
	
	if(hour > 0) {
		return hour+":"+min+":"+sec;
	} else {
		return hour+":"+min+":"+sec;
	}
}

function showProfileGraph(name, title, prefix, data, min, max, dataWidth, dataHeight) {
	
	// document.getElementById(name).width = document.getElementById(name).width;
	var context = document.getElementById(name).getContext("2d");
	context.clearRect(0,0,document.getElementById(name).width,document.getElementById(name).height);
	
	var width = document.getElementById(name).width;
	var height = document.getElementById(name).height;
	
	context.fillStyle = "#1e1e1e";
	context.fillRect(0, 0, width, height);
	
	var start = 0;
	var arr = data[0];
	if(arr.length > dataWidth) start = arr.length - dataWidth;
	
	var scale = width/360;
	var fontScale = scale;
	
	var limit = mHz;
	if(mPeriod == 60) limit = 60;
	for(var ch = 0; ch < 4; ch++) { 
		arr = data[ch];
		
		var dHeight = (dataHeight/4)-10;
		var dOffset = ch*(dataHeight/4);
		
		context.fillStyle = "#444444";
		context.fillRect(graphPaddingLeft, graphPaddingTop+dOffset, dataWidth, dHeight);
		
		context.strokeStyle = "#888888";
		context.beginPath();
		context.moveTo(graphPaddingLeft,graphPaddingTop+dOffset);
		context.lineTo(graphPaddingLeft,graphPaddingTop+dOffset+dHeight);
		context.lineTo(graphPaddingLeft+dataWidth,graphPaddingTop+dOffset+dHeight);
		context.stroke();
		
		for(i = start; i < arr.length-1; i++) {
			var x = i-start;
			
			var h = (arr[i]-min/4)/(max/4-min/4) * dHeight;
			if(h < 0) h = 0;
			if(h > dHeight) h = dHeight;
			
			context.strokeStyle = "#ffdd00";
			if(arr.length-i-limit > 0 && mPeriod < 1000) context.strokeStyle = "#ddaa00";
			context.beginPath();
			context.moveTo(graphPaddingLeft+x,graphPaddingTop+dOffset+dHeight);
			context.lineTo(graphPaddingLeft+x,graphPaddingTop+dOffset+dHeight-h);
			context.stroke();
		}
		
		var x = arr.length-start;
		context.strokeStyle = "#888888";
		context.beginPath();
		context.moveTo(graphPaddingLeft+x,graphPaddingTop+dOffset+dHeight);
		context.lineTo(graphPaddingLeft+x,graphPaddingTop+dOffset);
		context.stroke();
		
		context.font = "bold "+(parseInt(10*fontScale))+"pt Sans-serif";
		context.textAlign = "right";
		context.fillStyle = "#ffffff";
		// context.fillText(max/4, paddLeft-10, paddTop+dOffset+10);
		context.fillText("CH#"+(ch+1), graphPaddingLeft-10, graphPaddingTop+dOffset);
		// context.fillText(min, paddLeft-10, paddTop+dOffset+dHeight-10);
	}
	// alert("data "+str);
	
	context.textBaseline = "top";
	context.textAlign = "center";
	context.font = "bold "+(parseInt(16*fontScale))+"pt Sans-serif";
	context.fillStyle = "#aaaaaa";
	context.fillText(title+" ("+prefix+")", width/2, 10);
}

function showGraphs(name, title, prefix, arr, min, max, dataWidth, dataHeight) {
	
	var fontScale = 1;
	var red = color_alert; // "#d44040";
	var green = "#67a867";
	var yellow = color_active; // "#e1c649";
	// var zeroLine = 580;
	var zeroLine = graphPaddingTop+dataHeight;
	
	var context = document.getElementById(name).getContext("2d");
	context.clearRect(0,0,document.getElementById(name).width,document.getElementById(name).height);
	
	var width = document.getElementById(name).width;
	var height = document.getElementById(name).height;
	
	context.fillStyle = "#000000";
	context.fillRect(0, 30, width, height);
	
	var bg = document.getElementById("meter-img0");
	context.drawImage(bg, 0, 0, width, height);
	
	var start = 0;
	var smoothY = 3;
	
	context.lineWidth = 3;
	
	targetStart = parseInt(mGraphLeft);
	targetEnd = parseInt(mGraphRight);
	
	// Cadence
	/* var blue = "#a0a0a0";
	var arr = new Array();
	for(var i = 0; i < mDataExtra.length; i++) {
		arr[arr.length] = countCadence(i);
	}
	if(isHistory) {
		var arr2 = new Array();
		for(var i = parseInt((arr.length*mHz/dataWidth)*targetStart/mHz); i < (arr.length*mHz/dataWidth)*targetEnd/mHz; i++) {
			if(i < arr.length) arr2[arr2.length] = arr[i];
		}
		arr = arr2;
	}
	var yScale = dataHeight/180.0;
	var xScale = (dataWidth/mHz)/arr.length;
	
	context.strokeStyle = blue;
	context.beginPath();
	context.moveTo(graphPaddingLeft,zeroLine-arr[0]*yScale);
	var lastValue = 0;
	for(var i = 1; i < arr.length; i++) {
		if(arr[i] > 0) {
			context.lineTo(graphPaddingLeft+i*mHz*xScale,zeroLine-arr[i]*yScale);
			lastValue = arr[i];
		} else if(lastValue > 0) {
			context.lineTo(graphPaddingLeft+i*mHz*xScale,zeroLine-lastValue*yScale);
		}
	}
	context.stroke(); */
	
	// Cadence
	var blue = "#e0e0e0";
	var arr = new Array();
	// for(var i = 0; i < mDataExtra.length; i++) {
	for(var i = 0; i < mDataCount/mHz; i++) {
		arr[arr.length] = getSmoothCadences(i);
	}
	if(isHistory) {
		var arr2 = new Array();
		for(var i = parseInt((arr.length*mHz/dataWidth)*targetStart/mHz); i < (arr.length*mHz/dataWidth)*targetEnd/mHz; i++) {
			if(i < arr.length) arr2[arr2.length] = arr[i];
		}
		arr = arr2;
	}
	var yScale = dataHeight/180.0;
	var xScale = (dataWidth/mHz)/arr.length;
	
	context.strokeStyle = blue;
	context.beginPath();
	context.moveTo(graphPaddingLeft,zeroLine-arr[0]*yScale);
	var lastValue = 0;
	var lastX = 0-smoothY-1;
	var yCount = 0;
	var ySum = 0;
	for(var i = 1; i < arr.length; i++) {
		/* if(arr[i] >= 0) {
			context.lineTo(graphPaddingLeft+i*mHz*xScale,zeroLine-arr[i]*yScale);
			lastValue = arr[i];
		} else if(lastValue > 0) {
			context.lineTo(graphPaddingLeft+i*mHz*xScale,zeroLine-lastValue*yScale);
		} */
			var x = graphPaddingLeft+i*mHz*xScale;
			ySum += arr[i];
			yCount++;
			if(x > lastX+smoothY) {
				var y = ySum/yCount;
				lastX = x;
				context.lineTo(x,zeroLine-y*yScale);
				ySum = 0;
				yCount = 0;
			}
		if(arr[i] >= 0) {
		}
	}
	context.stroke();
	
	// Speed
	var arr = new Array();
	for(var i = 0; i < mDataExtra.length; i++) {
		var ar0 = mDataExtra[i];
		var ar1 = ar0.split(",");
		arr[arr.length] = parseInt(ar1[4]);
	}
	if(isHistory) {
		var arr2 = new Array();
		for(var i = parseInt((arr.length*mHz/dataWidth)*targetStart/mHz); i < (arr.length*mHz/dataWidth)*targetEnd/mHz; i++) {
			if(i < arr.length) arr2[arr2.length] = arr[i];
		}
		arr = arr2;
	}
	var yScale = dataHeight/40.0;
	var xScale = (dataWidth/mHz)/arr.length;
	
	context.strokeStyle = green;
	context.beginPath();
	context.moveTo(graphPaddingLeft,zeroLine-arr[0]*yScale);
	var lastX = 0-smoothY-1;
	var yCount = 0;
	var ySum = 0;
	for(var i = 1; i < arr.length; i++) {
		// context.lineTo(graphPaddingLeft+i*mHz*xScale,zeroLine-arr[i]*yScale);
		var x = graphPaddingLeft+i*mHz*xScale;
		ySum += arr[i];
		yCount++;
		if(x > lastX+smoothY) {
			var y = ySum/yCount;
			lastX = x;
			context.lineTo(x,zeroLine-y*yScale);
			ySum = 0;
			yCount = 0;
		}
	}
	context.stroke();
	
	// Heart rate
	var arr = mDataHR;
	if(isHistory) {
		var arr2 = new Array();
		for(var i = parseInt((arr.length*mHz/dataWidth)*targetStart/mHz); i < (arr.length*mHz/dataWidth)*targetEnd/mHz; i++) {
			if(i < arr.length) arr2[arr2.length] = arr[i];
		}
		arr = arr2;
	}
	var yScale = dataHeight/240.0;
	var xScale = (dataWidth/mHz)/arr.length;
	
	context.strokeStyle = color_alert;
	context.beginPath();
	context.moveTo(graphPaddingLeft,zeroLine-arr[0]*yScale);
	var lastX = 0-smoothY-1;
	var yCount = 0;
	var ySum = 0;
	for(var i = 1; i < arr.length; i++) {
		// context.lineTo(graphPaddingLeft+i*mHz*xScale,zeroLine-arr[i]*yScale);
		var x = graphPaddingLeft+i*mHz*xScale;
		ySum += arr[i];
		yCount++;
		if(x > lastX+smoothY) {
			var y = ySum/yCount;
			lastX = x;
			context.lineTo(x,zeroLine-y*yScale);
			ySum = 0;
			yCount = 0;
		}
	}
	context.stroke();
	
	// Muscle load
	var arr = new Array();
	var mmax = 0;
	var step = mDataCount/dataWidth;
	if(step < 1) step = 1;
	for(var j = 0; j < mDataCount; j++) {
		arr[parseInt(j/step)] = 0;
	}
	for(var i = 0; i < mChannelCount; i++) {
		for(var j = 0; j < mDataCount; j++) {
			arr[parseInt(j/step)] += (parseInt(mData[i][j])*1.0/step);
			if(arr[parseInt(j/step)] > mmax) mmax = parseInt(arr[parseInt(j/step)]);
		}
	}
	var arr2 = new Array(); // smooth / 29.5.2014 / jariha
	for(var i = 0; i < arr.length; i++) {
		/* if(i > 2) arr2[arr2.length] = (arr[i]+arr[i-1]+arr[i-2])/3;
		else if(i == 1) arr2[arr2.length] = (arr[i]+arr[i-1])/2;
		else arr2[arr2.length] = arr[i]; */
		var tmp = arr[i];
		var t = 1;
		if(i >= smoothTime) {
			for(var j = 1; j < smoothTime; j++) {
				tmp += arr[i-j];
				t++;
			}
		} else {
			for(var j = 1; j <= i; j++) {
				tmp += arr[i-j];
				t++;
			}
		}
		arr2[i] = tmp/t;
	}
	arr = arr2;
		
	var str = "";
	var limit = mHz;
	if(isHistory || mPeriod > 1) limit = (500*((mHz*mPeriod)/mDataCount)); // mPeriod; // 60;
	
	if(isHistory) {
		var arr2 = new Array();
		for(var i = targetStart; i < targetEnd; i++) {
			if(i < arr.length) arr2[arr2.length] = arr[i];
		}
		arr = arr2;
	}
	var xScale = (dataWidth)/arr.length;
	
	context.strokeStyle = color_active;
	context.beginPath();
	var lastX = 0-smoothY-1;
	var yCount = 0;
	var ySum = 0;
	for(i = 1; i < arr.length-1; i++) {
		var x = i-start;
		var h = arr[i]*1.0/mlScale/max*dataHeight; // (arr[i]*1.0/mlScale-min)/(max-min) * dataHeight;
		if(h < 0) h = 0;
		// if(h > dataHeight) h = dataHeight;
		
		if(i == start) context.moveTo(graphPaddingLeft+x*xScale,graphPaddingTop+dataHeight);
		else context.lineTo(graphPaddingLeft+x*xScale,graphPaddingTop+dataHeight-h);
		/* var x = graphPaddingLeft+(i-start)*xScale;
		ySum += arr[i];
		yCount++;
		if(x > lastX+smoothY) {
			var y = ySum/yCount;
			lastX = x;
			context.lineTo(x,graphPaddingTop+dataHeight-y*1.0/mlScale/max*dataHeight);
			ySum = 0;
			yCount = 0;
		} */
	}
	context.stroke();
	
	var scale = width/360;
	
	context.font = "bold "+(parseInt(20*fontScale))+"pt Sans-serif";
	context.textAlign = "center";
	context.fillStyle = yellow;
	context.fillText("Muscle Load", 150, 40);
	context.fillStyle = green;
	context.fillText("Speed", 320, 40);
	context.fillStyle = red;
	context.fillText("Heart Rate", 480, 40);
	
	var arr = new Array();
	for(var i = 0; i < mDataExtra.length; i++) {
		arr[arr.length] = getSmoothCadences(i);
	}
	var str = " ---- Cadences ("+arr.length+"): <br />";
	for(var i = 0; i < arr.length; i++) {
		if(i % 60 == 0) str += " / ";
		if(parseInt(arr[i]) == 0) str += "- ";
		else str += parseInt(arr[i])+" ";
	}
	var arr = new Array();
	for(var i = 0; i < mDataExtra.length; i++) {
		arr[arr.length] = cadencesTmp[i]; // countCadence(i);
	}
	str += "<br />------ <br />";
	for(var i = 0; i < arr.length; i++) {
		if(i % 60 == 0) str += " ---<br />";
		if(arr[i] == undefined) str += i+". - <br />"; 
		else str += i+". "+arr[i]+" <br />";
	}
	// document.getElementById("debug3").innerHTML = str;
}
