var mbodyServiceUuid = "d5ad63b5-579c-4da7-ac2c-597ecfaef76e";
var mbodyCharacteristicUuid = "eba11dc1-6fab-479b-a742-1a2dfad8f122";
var mbodyCharacteristic25Uuid = "eba11dc2-6fab-479b-a742-1a2dfad8f122";
var mbodyCharacteristicConfigDescriptorUuid = "00002902-0000-1000-8000-00805f9b34fb";

var hrServiceUuid = "180d";
var hrCharacteristicUuid = "2a37";
var hrCharacteristicConfigDescriptorUuid = "2902";
/* var hrBatteryServiceUuid = "180f";
var hrBatteryLevelCharacteristicUuid = "2a19"; */

var mbodyAddress = null;
var hrAddress = null;

var mbodyDeviceCount = 0;
var hrDeviceCount = 0;

var mbodyTry = 0;
var hrTry = 0;
var scan_started = false;

var useBT4 = true;

var bluetoothInitialized = false;

var bluetoothDevices = new Array();

var timerMbody = 0;
var timerHr = 0;
var timerOm4 = 0;

if (typeof String.prototype.startsWith != 'function') {
    // see below for better implementation!
    String.prototype.startsWith = function (str){
        return this.indexOf(str) == 0;
    };
}

// Discover starts
window.addEventListener('load', function () {
    document.addEventListener('deviceready', function () {
        if(window.localStorage.getItem("bt-device-text") != null && window.localStorage.getItem("bt-device-val") != null) {
            $('#bt-devices-select').html('');
            $('#bt-devices-select').append( $( '<option value="' + window.localStorage.getItem("bt-device-val") + '">' + window.localStorage.getItem("bt-device-text") + '</option>' ) );
        }
		if(window.localStorage.getItem("btle-device-text") != null && window.localStorage.getItem("btle-device-text") != "" && window.localStorage.getItem("btle-device-val") != null) {
			$('#btle-devices-select').html('');
            $('#btle-devices-select').append( $( '<option value="' + window.localStorage.getItem("btle-device-val") + '">' + window.localStorage.getItem("btle-device-text") + '</option>' ) );
		}
     }, false);
}, false);

// Scan
function bluetooth_discover() {
	console_log("bluetooth_mbody_discover");
	bluetoothDevices = new Array();
	if (cordova.platformId === 'android') ble.enable();
	showDialog("Please wait", "Discovering Bluetooth devices...", 15000);
    if (cordova.platformId === 'android') { // Android filtering is broken
		ble.scan([], 5, bluetooth_mbody_discover_success, bluetooth_mbody_discover_failed);
	} else {
		ble.scan([mbodyServiceUuid], 5, bluetooth_mbody_discover_success, bluetooth_mbody_discover_failed);
	}
	// setTimeout(bluetoothserial_list, 5000);
	setTimeout(bluetoothserial_discover, 3000);
}

function bluetooth_mbody_discover_success(device) {
	console_log("bluetooth_mbody_discover_success: "+device.name+" : "+device.id);
	if(device.name.indexOf("MbMS") == 0) {
		var alreadyInArray = false;
		for(var i = 0; i < bluetoothDevices.length; i++) {
			if(bluetoothDevices[i] == device.id + ';' + device.name) {
				alreadyInArray = true;
			}
		}
		if(!alreadyInArray) {
			bluetoothDevices[bluetoothDevices.length] = device.id + ';' + device.name;
			showBluetoothDialog(bluetoothDevices);
		}
	}
}

function bluetooth_mbody_discover_failed(reason) {
	console_log("bluetooth_mbody_discover_failed: "+reason);
    scan_started = false;
}

function discoverDevicesLE() {
	console_log("bluetooth_hr_discover");
	bluetoothDevices = new Array();
	showDialog("Please wait", "Discovering Bluetooth devices...", 10000);
    if (cordova.platformId === 'android') { // Android filtering is broken
		ble.scan([], 5, bluetooth_hr_discover_success, bluetooth_hr_discover_failed);
	} else {
		ble.scan([hrServiceUuid], 5, bluetooth_hr_discover_success, bluetooth_hr_discover_failed);
	}
}

function bluetooth_hr_discover_success(device) {
	console_log("bluetooth_hr_discover_success: "+device.name+" : "+device.id);
	if(device.name.indexOf("MbM") < 0) {
		var alreadyInArray = false;
		for(var i = 0; i < bluetoothDevices.length; i++) {
			if(bluetoothDevices[i] == device.id + ';' + device.name) {
				alreadyInArray = true;
			}
		}
		if(!alreadyInArray) {
			bluetoothDevices[bluetoothDevices.length] = device.id + ';' + device.name;
			showBluetoothLEDialog(bluetoothDevices);
		}
	}
}

function bluetooth_hr_discover_failed(reason) {
	console_log("bluetooth_hr_discover_failed: "+reason);
    scan_started = false;
}

// Connect

// Scan
function bluetooth_start() {
	console_log("bluetooth_start "+scan_started);
	if (cordova.platformId === 'android') ble.enable();
	if(!scan_started) {
		scan_started = true;
		if (cordova.platformId === 'android') { // Android filtering is broken
			ble.scan([], 3, bluetooth_start2b, bluetooth_mbody_discover_failed);
		} else {
			ble.scan([mbodyServiceUuid], 3, bluetooth_start2b, bluetooth_mbody_discover_failed);
		}
		setTimeout(bluetooth_start2, 3500);
	} else {
		bluetooth_start2();
	}
}

function bluetooth_start2() {
	console_log("bluetooth_start2");
    mbodyTry = 0;
    hrTry = 0;
    mbodyDeviceCount = 0;
    hrDeviceCount = 0;
    // ble.isEnabled(bluetooth_real_start1, bluetooth_discover_process);
    bluetooth_real_start(null);
}

function bluetooth_start2b(device) {
	console_log("bluetooth_start2b: "+device.name+" : "+device.id);
	/* if(!useMbody || device.name.indexOf("MbMS") == 0) {
		mbodyTry = 0;
		hrTry = 0;
		mbodyDeviceCount = 0;
		hrDeviceCount = 0;
		// ble.isEnabled(bluetooth_real_start1, bluetooth_discover_process);
		bluetooth_real_start(null);
	} */
}

function bluetooth_hr_start() {
	console_log("bluetooth_hr_start");
	if(!scan_started) {
		scan_started = true;
		if (cordova.platformId === 'android') { // Android filtering is broken
			ble.scan([], 5, bluetooth_hr_start2, bluetooth_mbody_discover_failed);
		} else {
			ble.scan([mbodyServiceUuid], 5, bluetooth_hr_start2, bluetooth_mbody_discover_failed);
		}
	} else {
		bluetooth_hr_start2();
	}
}

function bluetooth_hr_start2() {
	console_log("bluetooth_hr_start2");
    mbodyTry = 0;
    hrTry = 0;
    mbodyDeviceCount = 0;
    hrDeviceCount = 0;
	
	hrAddress = $( '#btle-devices-select' ).val();
	// if(useHR && hrAddress != "") {
	if(hrAddress != "" && hrAddress != null) {
		console_log("ble.connect hr "+hrAddress);
		ble.connect(hrAddress, bluetooth_hr_connect_success, bluetooth_hr_connect_failed);
	}
}

function bluetooth_discover_process() {
    console_log("bluetooth_discover_process");
    mbodyDeviceCount = 0;
    hrDeviceCount = 0;
    if(useMbody && mbodyAddress != "" && mbodyAddress != null) {
        console_log("scan");
        if (cordova.platformId === 'android') { // Android filtering is broken
            ble.scan([], 5, bluetooth_discover_process_hr, bluetooth_mbody_discover_failed);
        } else {
            ble.scan([mbodyServiceUuid], 5, bluetooth_discover_process_hr, bluetooth_mbody_discover_failed);
        }
        scan_started = true;
		if(timerMbody > 0) clearTimeout(timerMbody);
        timerMbody = setTimeout(bluetooth_scan_timeout, 1000);
    } else {
        bluetooth_discover_process_hr(null);
    }
}

function bluetooth_scan_timeout() {
    if(scan_started) {
        bluetooth_discover_process_hr(null);
        scan_started = false;
    }
}

function bluetooth_discover_process_hr(device) {
    console_log("bluetooth_discover_process_hr");
    scan_started = false;
    if(mbodyDeviceCount++ == 0) {
       console_log("scan hr");
       if(useHR && hrAddress != "" && hrAddress != null) {
            if (cordova.platformId === 'android') { // Android filtering is broken
                ble.scan([], 5, bluetooth_real_start, bluetooth_hr_discover_failed);
            } else {
                ble.scan([hrServiceUuid], 5, bluetooth_real_start, bluetooth_hr_discover_failed);
            }
           scan_started = true;
           if(timerHr > 0) clearTimeout(timerHr);
			timerHr = setTimeout(bluetooth_hr_scan_timeout, 1000);
        } else {
            bluetooth_real_start(device);
        }
    }
}

function bluetooth_hr_scan_timeout() {
    if(scan_started) {
        bluetooth_real_start(null);
        scan_started = false;
    }
}

function bluetooth_real_start1() {
	bluetooth_real_start(null);
}

function bluetooth_real_start(device) {
    scan_started = false;
    if(hrDeviceCount++ == 0) {
        mbodyAddress = $( '#bt-devices-select' ).val();
        console_log("bluetooth_real_start");
        if(useMbody && mbodyAddress != "" && mbodyAddress != null) {
            console_log("ble.connect "+mbodyAddress);
            ble.connect(mbodyAddress, bluetooth_mbody_connect_success, bluetooth_mbody_connect_failed);
        }
        hrAddress = $( '#btle-devices-select' ).val();
        // if(useHR && hrAddress != "") {
        if(!useMbody && hrAddress != "" && hrAddress != null) {
            console_log("ble.connect hr "+hrAddress);
            ble.connect(hrAddress, bluetooth_hr_connect_success, bluetooth_hr_connect_failed);
        }
    }
}

function bluetooth_mbody_connect_success() {
    if(mHz == 1) {
        // console_log("bluetooth_mbody_connect_success "+mHz);
        console_log("ble.notify "+mHz);
		ble.notify(mbodyAddress, mbodyServiceUuid, mbodyCharacteristicUuid, bluetooth_mbody_notify_success, bluetooth_mbody_notify_failed);
    } else {
		bt4Buffer = new Array();
		bt4BufferStatus = false;
        /* console_log("ble.writeCommand: om4");
        ble.writeCommand(mbodyAddress, mbodyServiceUuid, mbodyCharacteristic25Uuid, stringToBytes("om4\r"), bluetooth_mbody_write_success, bluetooth_mbody_write_failed); */
        // console_log("bluetooth_mbody_connect_success "+mHz);
        console_log("ble.notify "+mHz);
		ble.notify(mbodyAddress, mbodyServiceUuid, mbodyCharacteristic25Uuid, bluetooth_mbody_notify_success, bluetooth_mbody_notify_failed);
        
		if(timerOm4 > 0) clearTimeout(timerOm4);
        timerOm4 = setTimeout(bluetooth_mbody_write_om4, 400);
    }
    mbodyTry = 0;
    if(useHR && hrAddress != "" && hrAddress != null) {
        console_log("ble.connect hr "+hrAddress);
        ble.connect(hrAddress, bluetooth_hr_connect_success, bluetooth_hr_connect_failed);
    }
}

function bluetooth_mbody_write_om4() {
	console_log("ble.writeCommand: om4");
	ble.writeCommand(mbodyAddress, mbodyServiceUuid, mbodyCharacteristic25Uuid, stringToBytes("om4\r"), bluetooth_mbody_write_success, bluetooth_mbody_write_failed);
}

function bluetooth_mbody_write_success() {
    console_log("bluetooth_mbody_write_success");
}

function bluetooth_mbody_write_failed(reason) {
    console_log("bluetooth_mbody_write_failed: "+reason);
}

function bluetooth_mbody_connect_failed(reason) {
	console_log("bluetooth_mbody_connect_failed: "+reason);
    if(reason == "Disconnected" && mbodyTry++ == 0) {
        console_log("ble.disconnect");
        ble.disconnect(mbodyAddress, bluetooth_mbody_tryagain, bluetooth_mbody_disconnect_failed);
    } else if(reason.startsWith("Could not find peripheral") && mbodyTry++ == 0) {
        bluetooth_discover_process();
    } else if(reason.startsWith("Could not find peripheral") && useHR && hrAddress != "" && hrAddress != null) {
        console_log("ble.connect hr "+hrAddress);
        ble.connect(hrAddress, bluetooth_hr_connect_success, bluetooth_hr_connect_failed);
    } else if(reason.startsWith("Peripheral") && mbodyTry++ == 0) {
        bluetooth_discover_process();
    } else if(reason.startsWith("Peripheral") && useHR && hrAddress != "" && hrAddress != null) {
        console_log("ble.connect hr "+hrAddress);
        ble.connect(hrAddress, bluetooth_hr_connect_success, bluetooth_hr_connect_failed);
    }
}

function bluetooth_mbody_tryagain() {
    console_log("bluetooth_mbody_tryagain");
    if(useMbody && mbodyAddress != "" && mbodyAddress != null) {
        console_log("ble.connect "+mbodyAddress);
        ble.connect(mbodyAddress, bluetooth_mbody_connect_success, bluetooth_mbody_connect_failed);
    }
}

function bluetooth_hr_connect_success() {
	console_log("bluetooth_hr_connect_success");
    hrTry = 0;
	console_log("ble.notify hr");
	ble.notify(hrAddress, hrServiceUuid, hrCharacteristicUuid, bluetooth_hr_notify_success, bluetooth_hr_notify_failed);
}

function bluetooth_hr_connect_failed(reason) {
	console_log("bluetooth_hr_connect_failed: "+reason);
    if(reason != "Disconnected" && hrTry++ == 0) {
    // if(hrTry++ == 0) {
        if(useHR && hrAddress != "" && hrAddress != null) {
            console_log("ble.disconnect hr");
			ble.disconnect(hrAddress, bluetooth_hr_tryagain, bluetooth_hr_disconnect_failed);
        }
    }
}

function bluetooth_hr_tryagain() {
   console_log("bluetooth_hr_tryagain");
     if(useHR && hrAddress != "" && hrAddress != null) {
        console_log("ble.connect hr "+hrAddress);
        ble.connect(hrAddress, bluetooth_hr_connect_success, bluetooth_hr_connect_failed);
    }
}


// Notify
var lastBT4index = "";
var debugStamp = "";
var dataCount = 0;
var bt4Buffer = new Array();
var bt4BufferStatus = false;
var bufferlength = 303;
function bluetooth_mbody_notify_success(buffer) {
	var now = new Date().getTime();
	var bytes = new Uint8Array(buffer); // bluetoothle.encodedStringToBytes(buffer);
    // console_log("bluetooth_mbody_notify_success "+bytes.length);
	// if((mHz == 25 && bytes.length == 8) || mHz == 1) {
	if(true) {
		var str = "";
		for(var i = 0; i < bytes.length; i++) {
			var h = bytes[i].toString(16);
			if (h.length < 2) h = "0" + h;
			if(h.length == 2) str += h+" ";
		}
		dataCount++;
		if(debugStamp == "") debugStamp = createStamp();
		// console_log("Data ["+dataCount+"]: " + str);
		if(mHz == 1) {
			// filewriteappend_debugdata(debugStamp, "Data ["+dataCount+"]: " + str);
		} else {
			// filewriteappend_debugdata(debugStamp, "Data ["+dataCount+"] ");
			// str = "00 00 00 00 "+str;
		}
		if(mRunning) {
            mbodyClientTime = new Date().getTime();
            mbodyStatus = 2;
            // if(mHz == 25) {
            if(mHz == 25) {
                try {
				var btdata = str.trim().split(" ");
				if(!bt4BufferStatus) {
					if(bt4Buffer.length == 0) {
						// if(str.indexOf("00 01 2f 00 00 00 01 00 00 00 04") >= 0) {
							// btdata = str.substring(str.indexOf("00 01 2f 00 00 00 01 00 00 00 04")).trim().split(" ");
						if(str.indexOf("00 01 2f 00 00 00 01 00 00 00 04") >= 0) {
							btdata = str.substring(str.indexOf("00 01 2f 00 00 00 01 00 00 00 04")).trim().split(" ");
                            // console_log("bt4Buffer created.");
                            bt4Buffer = btdata;
							debugStamp = "";
							bufferlength = 303;
 						} else if(str.indexOf("00 01 bb 00 00 00 01 00 00 00 06") >= 0) {
							btdata = str.substring(str.indexOf("00 01 bb 00 00 00 01 00 00 00 06")).trim().split(" ");
                            // console_log("bt4Buffer created.");
                            bt4Buffer = btdata;
							debugStamp = "";
							bufferlength = 443;
 						}
					} else {
                        var l1 = bt4Buffer.length;
						// bt4Buffer.extend(btdata);
                        var s1 = "";
                        for(i1 = 0; i1 < bt4Buffer.length; i1++) {
                            if(bt4Buffer[i1] != "") s1 += bt4Buffer[i1]+" ";
                        }
                        for(i1 = 0; i1 < btdata.length; i1++) {
                            if(btdata[i1] != "") s1 += btdata[i1]+" ";
                        }
                        bt4Buffer = s1.trim().split(" ");
                        // console_log("length: "+l1+" + "+btdata.length+" -> "+bt4Buffer.length);
					}
					if(bt4Buffer.length >= bufferlength) {
						btdata = bt4Buffer;
						bt4BufferStatus = true;
                        // console_log( "HEADER DONE");
					} else {
                        // console_log( "HEADER: " + str);
						btdata = new Array();
					}
				}
                // console_log("btdata.length: "+btdata.length);
				if(btdata.length > 0) {
					var strDebug = "Data {"+str+"} "+(str.trim().split(" ").length)+" "+(mDataCount-mDataCountOld)+" "+(now-lastData)+"ms\n";
					if(debugStamp == "") debugStamp = createStamp();
					// $('#debug').html( "BT4: " + str + " writing " + debugStamp );
                    // console_log( "BT4: " + str); // writing " + debugStamp );
					filewriteappend_debugdata(debugStamp, strDebug);
					// lastBT4index = btdata[3];
					// $('#debug').html( "BT4: " + p_data + " parsing" );
					myontecData(btdata);
					// $('#debug').html( "BT4: " + p_data + " success" );
				}
                } catch(err) {
                    console_log(err.message);
                }
			} else {
				var btdata = str.trim().split(" ");
				if(btdata.length >= 12 && lastBT4index != btdata[3]) {
					lastBT4index = btdata[3];
					var str = "Data {"+str+"}\n";
					if(debugStamp == "") debugStamp = createStamp();
					
					// mSaveIndex = dataCount;
					
					myontecDataBT4(btdata);
				}
			}
		}
    }
	lastData = now;
}

function bluetooth_mbody_notify_failed(reason) {
	console_log("bluetooth_mbody_notify_failed: "+reason);
}

function bluetooth_hr_notify_success(buffer) {
	// console_log("bluetooth_hr_notify_success: "+buffer);
	
    var bytes = new Uint8Array(buffer); // bluetoothle.encodedStringToBytes(buffer);
	
	// Check for data
	if (bytes.length == 0) {
		mHR = 0;
		// console_log("Heart Rate: " + mHR);
		return;
	}
	
	// Get the first byte that contains flags
	var flag = bytes[0];
	
	//Check if u8 or u16 and get heart rate
	if ((flag & 0x01) == 1) {
		var u16bytes = bytes.buffer.slice(1, 3);
		var u16 = new Uint16Array(u16bytes)[0];
		mHR = u16;
	} else {
		var u8bytes = bytes.buffer.slice(1, 2);
		var u8 = new Uint8Array(u8bytes)[0];
		mHR = u8;
	}
    if(mHR > 254) mHR = 254;
    hrClientTime = new Date().getTime();
	// console_log("Heart Rate: " + mHR);
}

function bluetooth_hr_notify_failed(reason) {
	console_log("bluetooth_hr_notify_failed: "+reason);
}

// Disconnect
function bluetooth_stop() {
	console_log("bluetooth_stop");
	if(useMbody && mbodyAddress != "" && mbodyAddress != null) {
        if(mHz == 1) {
        } else {
            console_log("ble.writeCommand: omn");
            ble.writeCommand(mbodyAddress, mbodyServiceUuid, mbodyCharacteristic25Uuid, stringToBytes("omn\r"), bluetooth_mbody_write2_success, bluetooth_mbody_write2_failed);
        }
		// ble.disconnect(mbodyAddress, bluetooth_mbody_disconnect_success, bluetooth_mbody_disconnect_failed);
	}
	if(!useMbody && hrAddress != "" && hrAddress != null) {
		console_log("ble.disconnect hr");
		ble.disconnect(hrAddress, bluetooth_hr_disconnect_success, bluetooth_hr_disconnect_failed);
	}
}
function bluetooth_hr_stop() {
	console_log("bluetooth_hr_stop");
	if(hrAddress != "" && hrAddress != null) {
        console_log("ble.stopNotification hr");
		ble.stopNotification(hrAddress, hrServiceUuid, hrCharacteristicUuid, bluetooth_hr_stop_success, bluetooth_hr_stop_failed);
	}
}

function bluetooth_hr_stop_success() {
    console_log("bluetooth_hr_stop_success");
	if(hrAddress != "" && hrAddress != null) {
        console_log("ble.disconnect hr");
		ble.disconnect(hrAddress, bluetooth_hr_disconnect_success, bluetooth_hr_disconnect_failed);
	}
}

function bluetooth_hr_stop_failed() {
    console_log("bluetooth_hr_stop_failed");
	if(hrAddress != "" && hrAddress != null) {
        console_log("ble.disconnect hr");
		ble.disconnect(hrAddress, bluetooth_hr_disconnect_success, bluetooth_hr_disconnect_failed);
	}
}

function bluetooth_mbody_write2_success() {
    console_log("bluetooth_mbody_write2_success");
    console_log("ble.stopNotification");
    ble.stopNotification(mbodyAddress, mbodyServiceUuid, mbodyCharacteristic25Uuid, bluetooth_mbody_disconnect, bluetooth_mbody_disconnect);
    // ble.disconnect(mbodyAddress, bluetooth_mbody_disconnect_success, bluetooth_mbody_disconnect_failed);
}

function bluetooth_mbody_write2_failed() {
    console_log("bluetooth_mbody_write2_failed");
    console_log("ble.stopNotification");
    ble.stopNotification(mbodyAddress, mbodyServiceUuid, mbodyCharacteristic25Uuid, bluetooth_mbody_disconnect, bluetooth_mbody_disconnect);
    // ble.disconnect(mbodyAddress, bluetooth_mbody_disconnect_success, bluetooth_mbody_disconnect_failed);
}

function bluetooth_mbody_disconnect() {
    console_log("bluetooth_mbody_disconnect");
    console_log("ble.disconnect");
	ble.disconnect(mbodyAddress, bluetooth_mbody_disconnect_success, bluetooth_mbody_disconnect_failed);
	// setTimeout(bluetooth_hr_stop, 500);
}

function bluetooth_mbody_disconnect_success() {
	console_log("bluetooth_mbody_disconnect_success");
    
    if(useHR && hrAddress != "" && hrAddress != null) {
        console_log("ble.disconnect hr");
		ble.disconnect(hrAddress, bluetooth_hr_disconnect_success, bluetooth_hr_disconnect_failed);
    }
}

function bluetooth_mbody_disconnect_failed(reason) {
	console_log("bluetooth_mbody_disconnect_failed: "+reason);
}

function bluetooth_hr_disconnect_success() {
	console_log("bluetooth_hr_disconnect_success");
}

function bluetooth_hr_disconnect_failed(reason) {
	console_log("bluetooth_hr_disconnect_failed: "+reason);
}

// ASCII only
function stringToBytes(string) {
    var array = new Uint8Array(string.length);
    for (var i = 0, l = string.length; i < l; i++) {
        array[i] = string.charCodeAt(i);
    }
    return array.buffer;
}

// ASCII only
function bytesToString(buffer) {
    return String.fromCharCode.apply(null, new Uint8Array(buffer));
}

Array.prototype.extend = function(array) {
    array.forEach(this.push, this);
}

// Log

function console_clock() {
	var today=new Date();
	var h=today.getHours();
	var m=today.getMinutes();
	var s=today.getSeconds();
	h=checkTime(h);
	m=checkTime(m);
	s=checkTime(s);
	var clock = h+":"+m+":"+s;
	// alert(clock);
	
	return clock;
}

var console_txt = "";
function console_log(msg) {
    if(useDebug) {
        if(document.getElementById("debug3").innerHTML.length > 10000) {
            document.getElementById("debug3").innerHTML = "";
        }
		document.getElementById("debug3").innerHTML += msg+"<br />";
    }
	// if(fileSystem != null) filewriteappend("debug.txt", msg+"\n", doNothing);
	console_txt += console_clock()+" "+msg+"\n";
}
function console_save() {
	if(fileSystem != null) filewriteappend("debug.txt", console_txt, doNothing);
	console_txt = "";
}

function console_clear() {
    document.getElementById("debug3").innerHTML = "";
    document.getElementById("debug4").innerHTML = "";
}
