var addressKey = "address";

/* var heartRateServiceUuid = "180d";
var heartRateMeasurementCharacteristicUuid = "2a37";
var clientCharacteristicConfigDescriptorUuid = "2902"; */
var heartRateServiceUuid = "d5ad63b5-579c-4da7-ac2c-597ecfaef76e"
var heartRateMeasurementCharacteristicUuid = "eba11dc1-6fab-479b-a742-1a2dfad8f122"
var clientCharacteristicConfigDescriptorUuid = "00002902-0000-1000-8000-00805f9b34fb"
var batteryServiceUuid = "180f";
var batteryLevelCharacteristicUuid = "2a19";

var discoverScanTimer = null;
var scanTimer = null;
var connectTimer = null;
var reconnectTimer = null;

var iOSPlatform = "iOS";
var androidPlatform = "Android";

var address = null; // window.localStorage.getItem(addressKey);

var useBT4 = true;

var bluetoothInitialized = false;

// Discover starts
window.addEventListener('load', function () {
    document.addEventListener('deviceready', function () {
        if(window.localStorage.getItem("bt-device-text") != null && window.localStorage.getItem("bt-device-val") != null) {
            $('#bt-devices-select').append( $( '<option value="' + window.localStorage.getItem("bt-device-val") + '">' + window.localStorage.getItem("bt-device-text") + '</option>' ) );
        }
    }, false);
}, false);

var bluetoothDevices = new Array();

function bluetooth_discover() {
    dataCount = 0;
    $('#bt-devices-select').html('');
    bluetoothDevices = new Array();

    console_clear();
    console_log("Start discovering bluetooth devices");
    
    if(bluetoothInitialized) {
        var paramsObj = {"serviceUuids":[heartRateServiceUuid]};
        bluetoothle.startScan(discoverStartScanSuccess, discoverStartScanError, paramsObj);
    } else {
        bluetoothle.initialize(discoverInitializeSuccess, discoverInitializeError);
        
    }
}

function discoverInitializeSuccess(obj)
{
    if (obj.status == "enabled")
    {
        bluetoothInitialized = true;
        console_log("Bluetooth initialized successfully, starting scan for devices.");
        var paramsObj = {"serviceUuids":[heartRateServiceUuid]};
        bluetoothle.startScan(discoverStartScanSuccess, discoverStartScanError, paramsObj);
    }
    else
    {
        console_log("Unexpected initialize status: " + obj.status);
    }
}

function discoverInitializeError(obj)
{
    console_log("Initialize error: " + obj.error + " - " + obj.message);
}

function discoverStartScanSuccess(obj)
{
    if (obj.status == "scanResult")
    {
        // console_log("Stopping scan..");
        // bluetoothle.stopScan(discoverStopScanSuccess, discoverStopScanError);
        // discoverClearScanTimeout();
        var alreadyInArray = false;
        for(var i = 0; i < bluetoothDevices.length; i++) {
            if(bluetoothDevices[i] == obj.address + ';' + obj.name) {
                alreadyInArray = true;
            }
        }
        
        if(!alreadyInArray) {
            address = obj.address;
            bluetoothDevices[bluetoothDevices.length] = obj.address + ';' + obj.name;
            console_log("Scanned device: "+obj.name);
            // window.localStorage.setItem(addressKey, obj.address);
            // connectDevice(obj.address);
        }
        
        showDialog("Myontec", "Please wait, discovering bluetooth devices...");
        // showBluetoothDialog(bluetoothDevices);
    }
    else if (obj.status == "scanStarted")
    {
        console_log("Scan was started successfully, stopping in 10");
        discoverScanTimer = setTimeout(discoverScanTimeout, 10000);
    }
    else
    {
        console_log("Unexpected start scan status: " + obj.status);
    }
}

function discoverStartScanError(obj)
{
    console_log("Start scan error: " + obj.error + " - " + obj.message);
}

function discoverScanTimeout()
{
    console_log("Scanning time out, stopping");
    bluetoothle.stopScan(discoverStopScanSuccess, discoverStopScanError);
    showBluetoothDialog(bluetoothDevices);
}

function discoverClearScanTimeout()
{
    console_log("Clearing scanning timeout");
    if (discoverScanTimer != null)
    {
        clearTimeout(discoverScanTimer);
    }
}

function discoverStopScanSuccess(obj)
{
    if (obj.status == "scanStopped")
    {
        console_log("Scan was stopped successfully");
    }
    else
    {
        console_log("Unexpected stop scan status: " + obj.status);
    }
}

function discoverStopScanError(obj)
{
    console_log("Stop scan error: " + obj.error + " - " + obj.message);
}

// Discover ends

function initializeSuccess(obj)
{
    if (obj.status == "enabled")
    {
        console_log("Bluetooth initialized successfully, starting scan for devices.");
        // var address = null; // window.localStorage.getItem(addressKey);
        address = $( '#bt-devices-select' ).val();
        if (address == "")
        {
            var paramsObj = {"serviceUuids":[heartRateServiceUuid]};
            bluetoothle.startScan(startScanSuccess, startScanError, paramsObj);
        }
        else
        {
            connectDevice(address);
        }
    }
    else
    {
        console_log("Unexpected initialize status: " + obj.status);
    }
}

function initializeError(obj)
{
    console_log("Initialize error: " + obj.error + " - " + obj.message);
}

function startScanSuccess(obj)
{
    if (obj.status == "scanResult")
    {
        console_log("Stopping scan..");
        bluetoothle.stopScan(stopScanSuccess, stopScanError);
        clearScanTimeout();
        
        address = obj.address;
        window.localStorage.setItem(addressKey, obj.address);
        connectDevice(obj.address);
    }
    else if (obj.status == "scanStarted")
    {
        console_log("Scan was started successfully, stopping in 10");
        scanTimer = setTimeout(scanTimeout, 10000);
    }
    else
    {
        console_log("Unexpected start scan status: " + obj.status);
    }
}

function startScanError(obj)
{
    console_log("Start scan error: " + obj.error + " - " + obj.message);
}

function scanTimeout()
{
    console_log("Scanning time out, stopping");
    bluetoothle.stopScan(stopScanSuccess, stopScanError);
}

function clearScanTimeout()
{
    console_log("Clearing scanning timeout");
    if (scanTimer != null)
    {
        clearTimeout(scanTimer);
    }
}

function stopScanSuccess(obj)
{
    if (obj.status == "scanStopped")
    {
        console_log("Scan was stopped successfully");
    }
    else
    {
        console_log("Unexpected stop scan status: " + obj.status);
    }
}

function stopScanError(obj)
{
    console_log("Stop scan error: " + obj.error + " - " + obj.message);
}

function connectDevice(address)
{
    console_log("Begining connection to: " + address + " with 5 second timeout");
    var paramsObj = {"address":address};
    // bluetoothle.connect(connectSuccess, connectError, paramsObj);
    // connectTimer = setTimeout(connectTimeout, 5000);
    bluetoothle.connect(reconnectSuccess, reconnectError, paramsObj);
    reconnectTimer = setTimeout(reconnectTimeout, 5000);
}

function connectSuccess(obj)
{
    if (obj.status == "connected")
    {
        console_log("Connected to : " + obj.name + " - " + obj.address);
        
        clearConnectTimeout();
        
        tempDisconnectDevice();
    }
    else if (obj.status == "connecting")
    {
        console_log("Connecting to : " + obj.name + " - " + obj.address);
    }
    else
    {
        console_log("Unexpected connect status: " + obj.status);
        clearConnectTimeout();
    }
}

function connectError(obj)
{
    console_log("Connect error: " + obj.error + " - " + obj.message);
    clearConnectTimeout();
}

function connectTimeout()
{
    console_log("Connection timed out");
}

function clearConnectTimeout()
{
    console_log("Clearing connect timeout");
    if (connectTimer != null)
    {
        clearTimeout(connectTimer);
    }
}

function tempDisconnectDevice()
{
    console_log("Disconnecting from device to test reconnect");
    bluetoothle.disconnect(tempDisconnectSuccess, tempDisconnectError);
}

function tempDisconnectSuccess(obj)
{
    if (obj.status == "disconnected")
    {
        console_log("Temp disconnect device and reconnecting in 1 second. Instantly reconnecting can cause issues");
        setTimeout(reconnect, 1000);
    }
    else if (obj.status == "disconnecting")
    {
        console_log("Temp disconnecting device");
    }
    else
    {
        console_log("Unexpected temp disconnect status: " + obj.status);
    }
}

function tempDisconnectError(obj)
{
    console_log("Temp disconnect error: " + obj.error + " - " + obj.message);
}

function reconnect()
{
    console_log("Connecting with 5 second timeout");
    bluetoothle.reconnect(reconnectSuccess, reconnectError);
    reconnectTimer = setTimeout(reconnectTimeout, 5000);
}

function reconnectSuccess(obj)
{
    if (obj.status == "connected")
    {
        console_log("Connected to : " + obj.name + " - " + obj.address);
        
        clearReconnectTimeout();
        
        console_log("Discovering service");
        var paramsObj = {"serviceUuids":[heartRateServiceUuid]};
        bluetoothle.services(servicesHeartSuccess, servicesHeartError, paramsObj);
        /* if (window.device.platform == iOSPlatform)
        {
            console_log("Discovering heart rate service");
            var paramsObj = {"serviceUuids":[heartRateServiceUuid]};
            bluetoothle.services(servicesHeartSuccess, servicesHeartError, paramsObj);
        }
        else if (window.device.platform == androidPlatform)
        {
            console_log("Beginning discovery");
            bluetoothle.discover(discoverSuccess, discoverError);
        }
        else
        {
            console_log("window.device.platform: "+window.device.platform);
        } */
    }
    else if (obj.status == "connecting")
    {
        console_log("Connecting to : " + obj.name + " - " + obj.address);
    }
    else
    {
        console_log("Unexpected connect status: " + obj.status);
        // disconnectDevice();
        closeDevice();
        setTimeout(bluetooth_start, 1000);
    }
}

function reconnectError(obj)
{
    console_log("Reconnect error: " + obj.error + " - " + obj.message);
    // disconnectDevice();
    closeDevice();
}

function reconnectTimeout()
{
    console_log("Connection timed out");
}

function clearReconnectTimeout()
{
    console_log("Clearing connect timeout");
    if (reconnectTimer != null)
    {
        clearTimeout(reconnectTimer);
    }
}

function servicesHeartSuccess(obj)
{
    if (obj.status == "discoveredServices")
    {
        var serviceUuids = obj.serviceUuids;
        for (var i = 0; i < serviceUuids.length; i++)
        {
            var serviceUuid = serviceUuids[i];
            
            if (serviceUuid == heartRateServiceUuid)
            {
                console_log("Finding characteristics");
                var paramsObj = {"serviceUuid":heartRateServiceUuid, "characteristicUuids":[heartRateMeasurementCharacteristicUuid]};
                bluetoothle.characteristics(characteristicsHeartSuccess, characteristicsHeartError, paramsObj);
                return;
            }
        }
        console_log("Error: service not found");
    }
    else
    {
        console_log("Unexpected services status: " + obj.status);
    }
    disconnectDevice();
}

function servicesHeartError(obj)
{
    console_log("Services error: " + obj.error + " - " + obj.message);
    disconnectDevice();
}

function characteristicsHeartSuccess(obj)
{
    if (obj.status == "discoveredCharacteristics")
    {
        var characteristicUuids = obj.characteristicUuids;
        for (var i = 0; i < characteristicUuids.length; i++)
        {
            console_log("Characteristics found, now discovering descriptor");
            var characteristicUuid = characteristicUuids[i];
            
            if (characteristicUuid == heartRateMeasurementCharacteristicUuid)
            {
                var paramsObj = {"serviceUuid":heartRateServiceUuid, "characteristicUuid":heartRateMeasurementCharacteristicUuid};
                bluetoothle.descriptors(descriptorsHeartSuccess, descriptorsHeartError, paramsObj);
                return;
            }
        }
        console_log("Error: Characteristic not found.");
    }
    else
    {
        console_log("Unexpected characteristics status: " + obj.status);
    }
    disconnectDevice();
}

function characteristicsHeartError(obj)
{
    console_log("Characteristics error: " + obj.error + " - " + obj.message);
    disconnectDevice();
}

function descriptorsHeartSuccess(obj)
{
    if (obj.status == "discoveredDescriptors")
    {
        // console_log("Discovered heart descriptors, now discovering battery service");
        // var paramsObj = {"serviceUuids":[batteryServiceUuid]};
        // bluetoothle.services(servicesBatterySuccess, servicesBatteryError, paramsObj);
        
        console_log("Discovered descriptors");
        console_log("Subscribing...");
        var paramsObj = {"serviceUuid":heartRateServiceUuid, "characteristicUuid":heartRateMeasurementCharacteristicUuid};
        bluetoothle.subscribe(subscribeSuccess, subscribeError, paramsObj);
        // setTimeout(unsubscribeDevice, 5000);
    }
    else
    {
        console_log("Unexpected descriptors status: " + obj.status);
        disconnectDevice();
    }
}

function descriptorsHeartError(obj)
{
    console_log("Descriptors error: " + obj.error + " - " + obj.message);
    disconnectDevice();
}

function servicesBatterySuccess(obj)
{
    if (obj.status == "discoveredServices")
    {
        var serviceUuids = obj.serviceUuids;
        for (var i = 0; i < serviceUuids.length; i++)
        {
            var serviceUuid = serviceUuids[i];
            
            if (serviceUuid == batteryServiceUuid)
            {
                console_log("Found battery service, now finding characteristic");
                var paramsObj = {"serviceUuid":batteryServiceUuid, "characteristicUuids":[batteryLevelCharacteristicUuid]};
                bluetoothle.characteristics(characteristicsBatterySuccess, characteristicsBatteryError, paramsObj);
                return;
            }
        }
        console_log("Error: battery service not found");
    }
    else
    {
        console_log("Unexpected services battery status: " + obj.status);
    }
    disconnectDevice();
}

function servicesBatteryError(obj)
{
    console_log("Services battery error: " + obj.error + " - " + obj.message);
    disconnectDevice();
}

function characteristicsBatterySuccess(obj)
{
    if (obj.status == "discoveredCharacteristics")
    {
        var characteristicUuids = obj.characteristicUuids;
        for (var i = 0; i < characteristicUuids.length; i++)
        {
            var characteristicUuid = characteristicUuids[i];
            
            if (characteristicUuid == batteryLevelCharacteristicUuid)
            {
                readBatteryLevel();
                return;
            }
        }
        console_log("Error: Battery characteristic not found.");
    }
    else
    {
        console_log("Unexpected characteristics battery status: " + obj.status);
    }
    disconnectDevice();
}

function characteristicsBatteryError(obj)
{
    console_log("Characteristics battery error: " + obj.error + " - " + obj.message);
    disconnectDevice();
}

function discoverSuccess(obj)
{
    if (obj.status == "discovered")
    {
        console_log("Discovery completed");
        
        readBatteryLevel();
    }
    else
    {
        console_log("Unexpected discover status: " + obj.status);
        disconnectDevice();
    }
}

function discoverError(obj)
{
    console_log("Discover error: " + obj.error + " - " + obj.message);
    disconnectDevice();
}

function readBatteryLevel()
{
    console_log("Reading battery level");
    var paramsObj = {"serviceUuid":batteryServiceUuid, "characteristicUuid":batteryLevelCharacteristicUuid};
    bluetoothle.read(readSuccess, readError, paramsObj);
}

function readSuccess(obj)
{
    if (obj.status == "read")
    {
        var bytes = bluetoothle.encodedStringToBytes(obj.value);
        console_log("Battery level: " + bytes[0]);
        
        console_log("Subscribing to heart rate for 5 seconds");
        var paramsObj = {"serviceUuid":heartRateServiceUuid, "characteristicUuid":heartRateMeasurementCharacteristicUuid};
        bluetoothle.subscribe(subscribeSuccess, subscribeError, paramsObj);
        // setTimeout(unsubscribeDevice, 5000);
    }
    else
    {
        console_log("Unexpected read status: " + obj.status);
        disconnectDevice();
    }
}

function readError(obj)
{
    console_log("Read error: " + obj.error + " - " + obj.message);
    disconnectDevice();
}

var lastBT4index = "";
var debugStamp = "";
var dataCount = 0;
function subscribeSuccess(obj)
{
    if (obj.status == "subscribedResult")
    {
        /* console_log("Subscription data received");
        
        //Parse array of int32 into uint8
        var bytes = bluetoothle.encodedStringToBytes(obj.value);
        
        //Check for data
        if (bytes.length == 0)
        {
            console_log("Subscription result had zero length data");
            return;
        }
        
        //Get the first byte that contains flags
        var flag = bytes[0];
        
        //Check if u8 or u16 and get heart rate
        var hr;
        if ((flag & 0x01) == 1)
        {
            var u16bytes = bytes.buffer.slice(1, 3);
            var u16 = new Uint16Array(u16bytes)[0];
            hr = u16;
        }
        else
        {
            var u8bytes = bytes.buffer.slice(1, 2);
            var u8 = new Uint8Array(u8bytes)[0];
            hr = u8;
        }
        console_log("Heart Rate: " + hr); */
        var bytes = bluetoothle.encodedStringToBytes(obj.value);
        var str = "";
        for(var i = 0; i < bytes.length; i++) {
            var h = bytes[i].toString(16);
            if (h.length < 2) h = "0" + h;
            str += h+" ";
        }
        dataCount++;
        if(debugStamp == "") debugStamp = createStamp();
        console_log("Data ["+dataCount+"]: " + str);
        filewriteappend_debugdata(debugStamp, "Data ["+dataCount+"]: " + str);
        if(mRunning) {
            var btdata = str.trim().split(" ");
            if(btdata.length >= 12 && lastBT4index != btdata[3]) {
                lastBT4index = btdata[3];
                var str = "Data {"+str+"}\n";
                if(debugStamp == "") debugStamp = createStamp();
                // $('#debug').html( "BT4: " + p_data + " writing " + debugStamp );
                // filewriteappend_debugdata(debugStamp, str);
                // $('#debug').html( "BT4: " + p_data + " parsing" );
                
                mSaveIndex = dataCount;
                
                myontecDataBT4(btdata);
                // $('#debug').html( "BT4: " + p_data + " success" );
            }
        }
    }
    else if (obj.status == "subscribed")
    {
        console_log("Subscription started");
    }
    else
    {
        console_log("Unexpected subscribe status: " + obj.status);
        disconnectDevice();
    }
}

function subscribeError(msg)
{
    console_log("Subscribe error: " + obj.error + " - " + obj.message);
    disconnectDevice();
}

function unsubscribeDevice()
{
    console_log("Unsubscribing service");
    var paramsObj = {"serviceUuid":heartRateServiceUuid, "characteristicUuid":heartRateMeasurementCharacteristicUuid};
    bluetoothle.unsubscribe(unsubscribeSuccess, unsubscribeError, paramsObj);
}

function unsubscribeSuccess(obj)
{
    if (obj.status == "unsubscribed")
    {
        console_log("Unsubscribed device");
        
        console_log("Reading client configuration descriptor");
        var paramsObj = {"serviceUuid":heartRateServiceUuid, "characteristicUuid":heartRateMeasurementCharacteristicUuid, "descriptorUuid":clientCharacteristicConfigDescriptorUuid};
        bluetoothle.readDescriptor(readDescriptorSuccess, readDescriptorError, paramsObj);
        // disconnectDevice();
    }
    else
    {
        console_log("Unexpected unsubscribe status: " + obj.status);
        disconnectDevice();
    }
}

function unsubscribeError(obj)
{
    console_log("Unsubscribe error: " + obj.error + " - " + obj.message);
    disconnectDevice();
}

function readDescriptorSuccess(obj)
{
    if (obj.status == "readDescriptor")
    {
        var bytes = bluetoothle.encodedStringToBytes(obj.value);
        var u16Bytes = new Uint16Array(bytes.buffer);
        console_log("Read descriptor value: " + u16Bytes[0]);
        disconnectDevice();
    }
    else
    {
        console_log("Unexpected read descriptor status: " + obj.status);
        disconnectDevice();
    }
}

function readDescriptorError(obj)
{
    console_log("Read Descriptor error: " + obj.error + " - " + obj.message);
    disconnectDevice();
}

function disconnectDevice()
{
    bluetoothle.disconnect(disconnectSuccess, disconnectError);
}

function disconnectSuccess(obj)
{
    if (obj.status == "disconnected")
    {
        console_log("Disconnect device");
        closeDevice();
    }
    else if (obj.status == "disconnecting")
    {
        console_log("Disconnecting device");
    }
    else
    {
        console_log("Unexpected disconnect status: " + obj.status);
    }
}

function disconnectError(obj)
{
    console_log("Disconnect error: " + obj.error + " - " + obj.message);
}

function closeDevice()
{
    bluetoothle.close(closeSuccess, closeError);
}

function closeSuccess(obj)
{
    if (obj.status == "closed")
    {
        console_log("Closed device");
    }
    else
    {
        console_log("Unexpected close status: " + obj.status);
    }
}

function closeError(obj)
{
    console_log("Close error: " + obj.error + " - " + obj.message);
}

function bluetooth_start() {
    // dataCount = 0;
    debugStamp = "";
    console_clear();
    // console_log("bluetooth_start");
    if (address == null)
    {
        try {
            bluetoothle.initialize(initializeSuccess, initializeError);
        } catch(err) {
            console_log(err);
        }
    }
    else
    {
        console_log("connect "+address);
        connectDevice(address);
    }
}

function bluetooth_stop() {
    unsubscribeDevice();
}

function console_log(msg) {
    if(useDebug) document.getElementById("debug3").innerHTML += msg+"<br />";
}

function console_clear() {
    document.getElementById("debug3").innerHTML = "";
    document.getElementById("debug4").innerHTML = "";
}
